***********************************************************************************************************
The J1699-5 software
***********************************************************************************************************


-- Version 04 J1699-5


Revision 04.13.01

CheckIDSupport.c
issue 5-10436 - Test 5.6, 5.10, and 5.17 did not flag a DIDSupported DID that supported nothing.

ConnectProtocol.c
issue 5-10417 - Test 10.1 DetermineOBDProtocol() works, but the Test 10.11 DetermineOBDProtocol() doesn’t. Vehicle uses 29-bit CAN IDs.

DetermineProtocol.c
issue 5-10417 - Test 10.1 DetermineOBDProtocol() works, but the Test 10.11 DetermineOBDProtocol() doesn’t. Vehicle uses 29-bit CAN IDs.
issue 5-10446 - Tests 10.11 FAILs with "FAILURE: ECU 18DAF111  INF $F810  Data Size = 254 (Must be 1 byte!)", but log show proper response to $F810.
issue 5-10449 - Test 5.2 - Receives normal mode traffic when searching for OBD Responses in 11-bit CAN.
issue 5-10450 - Test 10.1 - In IdentifyOBDProtocol() a positive response from a Classic OBD protocol will cause SaveOBDConnectInfo() to be called.

j1699.c
Update version number.
issue 5-10437 - Log of Fuel Type prints "DIESELCOMPRESSED NATURAL GAS/HYDROGENOTHER" when 'Diesel' is selected.

j1699.h
issue 5-10437 - Log of Fuel Type prints "DIESELCOMPRESSED NATURAL GAS/HYDROGENOTHER" when 'Diesel' is selected.

LogPrint.c
issue 5-10446 - Tests 10.11 FAILs with "FAILURE: ECU 18DAF111  INF $F810  Data Size = 254 (Must be 1 byte!)", but log show proper response to $F810.

RequestSID.c
issue 5-10451 - ProcessISO15765Msg() error message "ECU %X  reponded but not found during Determine Protocol\n" has a typo, should be "responded".
issue 5-10453 - Requirements for NRC $78 for Clear Codes: must allow up to 5sec for positive response and only one NRC $78 per ECU. Anything else is a FAILURE.

Test10_InUseCounters.c
issue 5-10431 - Test 9.16 reports "OBDCOND incremented too late (RUNTM = 30665)", but OBDCOND incremented in time and RUNTM = 30665 is incorrect based on DID $F41F.

Test11_PerformanceCounters.c
issue 5-10441 - ReadDTCIUMPRData() and ReadDTCSMADData() must load and process RGID=$00.
issue 5-10442 - Test 11.2 - The correct SMAD DTC count and list is not being used.
issue 5-10443 - Test 11.2 - The 'Get next IUMPR' and 'Get next SMAD' should not request Extended Data for DTCs with RGIDs that are in the 'Ignore list'.
issue 5-10444 - Tests 11.1, 11.2, 11.5, 11.7, and 11.12 - All evaluations on IUMPR ad SMAD Extended Data also includes DTCs with RGIDs that are in the 'Ignore list'.
issue 5-10445 - Test 11.2 - Change Results Logging on Exit.
issue 5-10460 - Test 11.2 - When loging results on exit, "I/M STATUS (continued)", but "OTH" is missing in the I/M STATUS log entry 
issue 5-10461 - In RunDynamicTest11(), the calls to CheckIUMPRData() and CheckSMADData() being called with update = FALSE, so that the Test11_CurrentDisplayData elements are not being updated and that is what PrintECUData() is looking printing to the log - so they end up printing the original default values. 

Test9_7to17_PermanentCodes.c
issue 5-10430 - Test 9.16 indicates "FAILURE: Unable to capture Initial OBDCOND and IGNCNT", but there was no FAILURE there… However, RequestIDSupportData() did fail, which triggered the log entry.

VerifyDTCExtData.c
issue 5-10443 - Test 11.2 - The 'Get next IUMPR' and 'Get next SMAD' should not request Extended Data for DTCs with RGIDs that are in the 'Ignore list'.
issue 5-10444 - Tests 11.1, 11.2, 11.5, 11.7, and 11.12 - All evaluations on IUMPR ad SMAD Extended Data also includes DTCs with RGIDs that are in the 'Ignore list'.
issue 5-10457 - Test 11.6 - Test Results value comparisons to Minimum Test Value or Maximum Test Value are not working for signed ranges.
issue 5-10458 - There is no need to check for Test 6.5 in LogDTCTestResultData().
issue 5-10462 - the log shows that Tests 10.10, 10.15, 11.1 - RGID is always $00 in log entry 

VerifyINFSupportAndData.c
issue 5-10381 - Test 12.7, DID F89C-F8A1 - Is the rule that “DIDs for Motor A-E output energy should be start at A and there should be no gap” is still valid?
issue 5-10409 - Test 12.7, DIDs F89C-F8A1 - There is no directions to move the vehicle after the clear codes so there must be NO WARNING if the Recent or Lifetime values are 0.
issue 5-10432 - Test 5.16 reports "INF $F81B CIFC-L must not be equal to CIFC-R" when they are not.
issue 5-10433 - Test 5.16 DID evaluations F885-8D, F896-97 are incorrect.
issue 5-10434 - Test 5.16 - Remove WARN (for any powertrain type) for DIDs $F81A, $F81B, and F81C if recent/lifetime values are 0 or are the same.
issue 5-10438 - Test 5.16 - There is a problem with vehicle applicability: $F877-$F878 is for MDDC with US_OBD_II, HD with HD_OBD.
issue 5-10439 - Test 10.10 - The logging of $F879 indicates the value is always "$02X", which is wrong but the decimal value is correct.
issue 5-10440 - In VerifyINF98_99Data() the log call contains "$F8$02X", but it should be "$F8%02X".

VerifyVerifyPermanentDTCData.c
issue 5-10435 - There is no FAILURE if Permanent DTCs are not supported by all ECUs and ECUs that do not respond when DTCs are expected get flagged with a 'Format ID' FAILURE (rather than Permanent DTCs not supported).

VerifyPIDSupportAndData.c
issue 5-10456 - Test 11.5 & 11.8 - No FAILURE flagged for COOL_SUP=1(YES) and COOL_RDY=1(NO).




Revision 04.13.00

ConnectProtocol.c
issue 5-10405 - With 11-bit CAN IDs, ECUs that did not respond to 22 F810 should be ignored (i.e., don't set up Flow Control filters).

DetermineProtocol.c
issue 5-10405 - With 11-bit CAN IDs, ECUs that did not respond to 22 F810 should be ignored (i.e., don't set up Flow Control filters).
issue 5-10417 - Test 10.1 DetermineOBDProtocol() works, but the Test 10.11 DetermineOBDProtocol() doesn’t. Vehicle uses 29-bit CAN IDs.
issue 5-10422 - Test 11.6 and beyond - DTC lists for IUMPR/Test Results/SMAD are being attributed to the wrong ECU ID, causing NRC $31 FAILUREs.

DoIP.c
issue 5-10406 - Test 12.1 - If Routing Activations response does not contain Routing Activation Code = 0x10, the DoIP is not supported. Do not retry.

j1699.c
	Update version number.
issue 5-10423 - Change "USER WARNING" text in USER_ERROR to "INSTRUCTION MISMATCH" as log entry preamble and in log error totals at end of log.

j1699.h
issue 5-10336 - Test 11.2 - Update display for RGID/IUMPR and SMAD.

LogPrint.c
issue 5-10423 - Change "USER WARNING" text in USER_ERROR to "INSTRUCTION MISMATCH" as log entry preamble and in log error totals at end of log.

RequestSID.c
issue 5-10417 - Test 10.1 DetermineOBDProtocol() works, but the Test 10.11 DetermineOBDProtocol() doesn’t. Vehicle uses 29-bit CAN IDs.
issue 5-10422 - Test 11.6 and beyond - DTC lists for IUMPR/Test Results/SMAD are being attributed to the wrong ECU ID, causing NRC $31 FAILUREs.

SaveSIDResponseData.c
issue 5-10336 - Test 11.2 - Update display for RGID/IUMPR and SMAD.
issue 5-10411 - Change IUMPR and SMAD value logging. Also, SMAR conversion is incorrect.
issue 5-10417 - Test 10.1 DetermineOBDProtocol() works, but the Test 10.11 DetermineOBDProtocol() doesn’t. Vehicle uses 29-bit CAN IDs.
issue 5-10422 - Test 11.6 and beyond - DTC lists for IUMPR/Test Results/SMAD are being attributed to the wrong ECU ID, causing NRC $31 FAILUREs.

Test10_InUseCounters.c
issue 5-10411 - Change IUMPR and SMAD value logging. Also, SMAR conversion is incorrect.

Test11_PerformanceCounters.c
issue 5-10336 - Test 11.2 - Update display for RGID/IUMPR and SMAD.
issue 5-10419 - Test 11.2 - Reports FAILURE when ESC pressed, but no indication of problem in log.
issue 5-10420 - Test 11.2 - Reported FAILURE count being logged is incorrect.
issue 5-10421 - Test 11.1 Re-Enter - DTC conversion error from log file loading: U code DTS are being interpreted as P Codes, so the subsequent SMAD request is getting an NRC $31.
issue 5-10427 - Test 11.2 - Change wording of navigation prompt.
issue 5-10428 - Test 11.7 - The FAILURE text for SMAD evaluation must change from "…has not changed since Test 10.10" to "…has decremented since Test 10.10".

Test12_ZEV.c
issue 5-10426 - Test 12 indicates PASS, even though some gTestSubsection FAILED.

VerifyDTCExtData.c
issue 5-10336 - Test 11.2 - Update display for RGID/IUMPR and SMAD.
issue 5-10411 - Change IUMPR and SMAD value logging. Also, SMAR conversion is incorrect.

VerifyINFSupportAndData.c
issue 5-10411 - Change IUMPR and SMAD value logging. Also, SMAR conversion is incorrect.

VerifyPIDSupportAndData.c
issue 5-10398 - Test 5.6, 5.10, and 10.13 Evaluation of DID $F501 per CCR 1968.2 (g)(4.1.2)(C). PID $F501 DATA_E Bit 1 (CV)., PID $F501 DATA_B Bit 1 (FUEL). Change FAILURE to WARNING if not supported.

VerifyVehicleState.c
issue 5-10423 - When there is an Engine State mismatch (on STOP/START vehicles ONLY), prompt "Is vehicle in Auto Stop? (Enter Yes or Quit)".




Revision 04.12.02

ConnectProtocol.c
issue 5-10383 - Test 9.19 no responses on 29-bit CAN after attempting ‘Checking for OBD on 500K ISO15765 11 Bit (Classic J1979 Services) protocol’, but CAN traffic show requests and responses are present. Improve logging text for failure tracking.

DetermineProtocol.c
issue 5-10383 - Test 9.19 no responses on 29-bit CAN after attempting ‘Checking for OBD on 500K ISO15765 11 Bit (Classic J1979 Services) protocol’, but CAN traffic show requests and responses are present. Appropriately handle SID $1 response in CheckFor29bitTA, improve logging text for failure tracking.

DisconnectProtocol.c
issue 5-10383 - Test 9.19 no responses on 29-bit CAN after attempting ‘Checking for OBD on 500K ISO15765 11 Bit (Classic J1979 Services) protocol’, but CAN traffic show requests and responses are present. Improve logging text for failure tracking.

DoIP.c
issue 5-10235 - J1699-5 should fail a vehicle that repetitively sends 'Vehicle Announcement' messages.

j1699.c
Update version number.
issue 5-10403 - Test 5.1 fails protocol determination, but log file also logs "Unable to continue Dynamic Tests".

j1699.h
issue 5-10394 - Test 11.1 is crashing after IUMPR, SMAD, and IPD Data has been collected on a first run through the Dynamic Test. 

RequestSID.c
issue 5-10211 - NRC $21 (Busy Repeat request) should be allowed for $22 $F810 request during initialization of DoIP, just as it is for CAN in ISO 15765-4.
issue 5-10383 - Test 9.19 no responses on 29-bit CAN after attempting ‘Checking for OBD on 500K ISO15765 11 Bit (Classic J1979 Services) protocol’, but CAN traffic show requests and responses are present. Appropriately handle depricated service request/response and improve logging text for failure tracking.

SaveSIDResponseData.c
issue 5-10394 - Test 11.1 is crashing after IUMPR, SMAD, and IPD Data has been collected on a first run through the Dynamic Test. 

Test10_InUseCounters.c
issue 5-10410 - Test 10.10 on screen IUMPR and SMAD percent completed progress display.
issue 5-10399 - Test 11.1 fails with the error "FAILURE: Could not find Test 10.10 IPD and DTCIUMPR data in log file." even though the required information appears to be in the log file.
issue 5-10401 - Test 10.12 logs IUMPR and SMD without making network requests. IUMPR and SMAD are not part of this test and should not be logged.

Test11_PerformanceCounters.c
issue 5-10394 - Test 11.1 is crashing after IUMPR, SMAD, and IPD Data has been collected on a first run through the Dynamic Test. 
issue 5-10399 - Test 11.1 fails with the error "FAILURE: Could not find Test 10.10 IPD and DTCIUMPR data in log file." even though the required information appears to be in the log file.

Test5_NoDTC.c
issue 5-10383 - Test 9.19 no responses on 29-bit CAN after attempting ‘Checking for OBD on 500K ISO15765 11 Bit (Classic J1979 Services) protocol’, but CAN traffic show requests and responses are present. Check $F810 inside DetermineOBDProtocol, in case response is overwritten by subsequent protocol failure.

Test6_PendingDTC.c
issue 5-10397 - Test 6.2 - Test should prompt if no Pending DTC after 30 seconds to continue with FAIL.

Test12_ZEV.c
issue 5-10227 - Is Test 12.3 (Protocol Identification in document) really needed? Should Test 12.3 (PSA Active in document) be merged with Test 12.5 (Clear DTCs in document).

Test9_NoFaultsAfter3DriveCycles.c
issue 5-10383 - Test 9.19 no responses on 29-bit CAN after attempting ‘Checking for OBD on 500K ISO15765 11 Bit (Classic J1979 Services) protocol’, but CAN traffic show requests and responses are present. Remove DetermineOBDProrocol() call.

Test9_7to17_PermanentCodes.c
issue 5-10404 - Test 9.16 - When test fails Screen says "Errors detected during Dynamic Test "… remove word "Dynamic".

VerifyDTCExtData.c
issue 5-10410  - Test 10.10 on screen IUMPR and SMAD percent completed progress display.
issue 5-10400 - Test 10.7 passes, but there are no Test Results requested even though Test 10.3 shows that there are Test Result DTC (via 19 1A 92). This impacts all Extended DTC Data requests - IUMPR, Test Results, and SMAD.

VerifyECUCommunication.c
issue 5-10211 - NRC $21 (Busy Repeat request) should be allowed for $22 $F810 request during initialization of DoIP, just as it is for CAN in ISO 15765-4.

VerifyPIDSupportAndData.c
issue 5-10407 - Update $F501 Data B, BIT 6 evaluation.




Revision 04.12.01

ClearCodes.c
issue 5-10322 - Test 12.5 fails if all ECUs don't respond the same, but there is no requirement to clear codes with PSA = Active.

DoIP.c
issue 5-10386 - Test 12.4 is WARNING “Unsupported INF $F810 Detected”, but DIDSupported DIDs have not been requested yet. Test 12.4 is re-connect.

j1699.c
	Update version number.
issue 5-10390 - Test 6.2 is crashing.  Allocate memory for extra ECUs (ECUs which did not respond to initial connection)

RequestSID.c
5-10389 - Test 12.8 is not detecting DTC Format that is not 4 for Pending DTCs.  Do not send requests for un-setup ECUs (not as many ECUs as user entered).

SaveSIDResponseData.c
issue 5-10324 - Test 10.10 - Need to clearly define the evaluation Criteria when an ECU does not have any DTCs in a given readiness group (19 56 33 xx requests). Fail ECUs which respond with no RG data.
issue 5-10395 - Test 5.6 & 5.10 DID cleanup.

Test10_InUseCounters.c
issue 5-10390 - Test 6.2 is crashing.  Allocate memory for extra ECUs (ECUs which did not respond to initial connection)

Test11_PerformanceCounters.c
issue 5-10343 - Test 11.7 - The Evaluation Criteria lists "each DTC supporting DTC based IUMPR… should have changed from the values recorded in 10.10.", but it should say "each DTC from the required Readiness Groups supporting DTC based IUMPR… should have changed from the values recorded in 10.10.".
issue 5-10372 - Test 11.12 - Add the evaluation of SMAD to the test.
issue 5-10377 - Tests 10.7, 10.10, are not logging the decoded IUMPR, Test Results, SMAD data.
issue 5-10390 - Test 6.2 is crashing.  Allocate memory for extra ECUs (ECUs which did not respond to initial connection)
issue 5-10394 - Test 11.1 is crashing after IUMPR, SMAD, and IPD Data has been collected on a first run thorugh the Dynamic Test. 

Test6_PendingDTC.c
issue 5-10379 - Test 6.4 & 7.4 - Remove Functionally requested Freeze Frames.

Test7_ConfirmedDTC.c
issue 5-10379 - Test 6.4 & 7.4 - Remove Functionally requested Freeze Frames.

VerifyConfirmedDTCData.c
issue 5-10389 - Test 12.8 is not detecting DTC Format that is not 4 for Pending DTCs.  Ignore un-setup ECUs (not as many ECUs as user entered).

VerifyDTCExtData.c
issue 5-10373 - Test 10.10 Does not print Readiness Group list of DTCs.
issue 5-10375 - Test 10.10 is not requesting Readiness Group $00.
issue 5-10377 - Tests 10.7, 10.10, are not logging the decoded IUMPR, Test Results, SMAD data.
issue 5-10389 - Test 12.8 is not detecting DTC Format that is not 4 for Pending DTCs.  Ignore un-setup ECUs (not as many ECUs as user entered).
issue 5-10392 - Test 10.10 has an infinite loop when processing RGIDs.  Make Readiness Group data index a WORD.

VerifyECUCommunication.c
issue 5-10389 - Test 12.8 is not detecting DTC Format that is not 4 for Pending DTCs.  Ignore un-setup ECUs (not as many ECUs as user entered).

VerifyFFSupportAndData.c
issue 5-10391 - Test 6.4, 7.4, 8.4, 9.5 - Freeze Frame evaluations must FAIL any ECU that has DIDSupported DIDs in the Snapshot Record and are currently not decoding them correctly.

VerifyINFSupportAndData.c
issue 5-10380 - Test 12.7 - WARNs when the value of Lifetime/Recent Average Battery Temperature (F88E) is 0 Deg. C, but it should FAIL only if the raw value is 0 (i.e., -40 Deg C).
issue 5-10384 - Evaluation of $F81C incorrectly compares CDEOGE-R to CDEOGE-L.

VerifyPendingDTCData.c
issue 5-10389 - Test 12.8 is not detecting DTC Format that is not 4 for Pending DTCs.  Ignore un-setup ECUs (not as many ECUs as user entered).

VerifyPIDSupportAndData.c
issue 5-10395 - Test 5.6 & 5.10 DID cleanup.



Revision 04.12.00

j1699.c
	Update version number.
issue 5-10342 - Test 10.3 - Treats a re-entry when ECU VIN is invalid and User enters VIN manually as a re-start of the Dynamic Tests instead of a continuation.
issue 5-10362 - Entering Mfg. name with space is accepted, but when log file is created the name ends where the space in Mfg. name is.   Allow spaces in Make and Model names in static test.

j1699.h
issue 5-10365 - Test 10.3 is locking up at the '18 DA 10 F1 19 1A 93' request while "Receiving segmented responses, please wait…". Increase MAX_LOG_STRING_SIZE to 12416 to accommodate 4k of data as 3 characters each in log string.
issue 5-10366 - Test 10.3 crashes when receiving 19 1A 93 response of 2280 bytes. Increase MAX_LOG_STRING_SIZE to 12416 to accommodate 4k of data as 3 characters each in log string.
issue 5-10241 - Tests that get Extended Data ($91, $92, $93) should FAIL if a request gets a NRC $31 OR if the ECU responds positively if that DTC is not supported.  Add gbAllECUResetCompleted to indicate response data has already been reset (for all ECUs) when doing physically addressed requests.
issue 5-10309 - Need to remove superset DTC list from Tests that request Extended Data. No need to round-robin the ECU DTC requests… do all DTCs for one ECU at a time.

RequestSID.c
issue 5-10241 - Tests that get Extended Data ($91, $92, $93) should FAIL if a request gets a NRC $31 OR if the ECU responds positively if that DTC is not supported.
issue 5-10361 - Test 12.2 - The software is not waiting for a response time-out, for ECUs that respond with a valid NRC $78 to a physically sent request, before continuing with the next ECU in the ECU list.

ResetSIDResponseData.c
issue 5-10241 - Tests that get Extended Data ($91, $92, $93) should FAIL if a request gets a NRC $31 OR if the ECU responds positively if that DTC is not supported.

SaveSIDResponseData.c
issue 5-10319 - Test 5.6 will not evaluate any DID responses if one ECU responds incorrectly.

Test10_InUseCounters.c
issue 5-10342 - Test 10.3 - Treats a re-entry when ECU VIN is invalid and User enters VIN manually as a re-start of the Dynamic Tests instead of a continuation.
issue 5-10362 - Entering Mfg. name with space is accepted, but when log file is created the name ends where the space in Mfg. name is.   Allow spaces in Make and Model names in static test.

Test11_PerformanceCounters.c
issue 5-10309 - Need to remove superset DTC list from Tests that request Extended Data. No need to round-robin the ECU DTC requests… do all DTCs for one ECU at a time.

VerifyDTCExtData.c
issue 5-10309 - Need to remove superset DTC list from Tests that request Extended Data. No need to round-robin the ECU DTC requests… do all DTCs for one ECU at a time.
issue 5-10370 - Test 10.15 - SMAD numerator should be allowed to increment by more than 1 since Test 10.10.

VerifyECUCommunication.c
issue 5-10360 - Tests 5-11 Reconnecting to CAN must include up to 5 attempts of the $F810 DID request.

VerifyFFSupportAndData.c
issue 5-10241 - Reset all ECU's response data only on the first physically addressed request.

VerifyINFSupportAndData.c
issue 5-10241 - Reset all ECU's response data only on the first physically addressed request.
issue 5-10376 - Test 5.16 – INF F877 Bytes 12-35 may be allowed to be $FFFFFFFF when the distance is unavailable.
issue 5-10378 - Test 12.7 - Change the evaluation of INF $F89A Byte 4. It must be non-0 if INFs F891-F893 are supported.

VerifyMIDSupportAndResults.c
issue 5-10241 - Reset all ECU's response data only on the first physically addressed request.

VerifyMILData.c
issue 5-10241 - Reset all ECU's response data only on the first physically addressed request.

VerifyPIDSupportAndData.c
issue 5-10241 - Reset all ECU's response data only on the first physically addressed request.
issue 5-10319 - Test 5.6 will not evaluate any DID responses if one ECU responds incorrectly.
issue 5-10369 - Test 5.10 - F501, DATA_F, bit 5 (CSERS) Document says 'must be 1', but comment seems to allow 1 or 0. Document says WARN, but software logs FAILURE.
issue 5-10371 - DID $F501, F43D, F43E, F43F, F4CF Evaluation updates.



Revision 04.11.02

CheckIDSupport.c
issue 5-10351 - Test  5.16, 12.7 - Reported "DID $F8A0  NAK $31 (Unsupported DID request) for functionally addressed request!", but this request was Physically Addressed.

DoIP.c
issue 5-10352 - $F810 requests for ECU detection must be functionally addressed.

j1699.c
	Update version number.

RequestSID.c
issue 5-10350 - Test  5.16, 12.7 - NRC $31 being flagged as a FAILURE for Physically Addressed SID $22 $F8xx DIDSupported DID requests - but not consistently.

ResetSIDResponseData.c
issue 5-10350 - Test  5.16, 12.7 - NRC $31 being flagged as a FAILURE for Physically Addressed SID $22 $F8xx DIDSupported DID requests - but not consistently.

Test11_PerformanceCounters.c
issue 5-10158 - Test 11.5 must also check DIDs $F431/$F44E.

Test5_NoDTC.c
issue 5-10358 - Test 5.13 contains "Failure: Test ResultList error", which is a summary statement that must be removed, but was missed.

VerifyDTCExtData.c
issue 5-10349 - Test 11.7 is not correctly evaluation signed Test Results data.

VerifyFFSupportAndData.c
issue 5-10364 - Test 6.4 is stuck in an infinite loop.  Include DTC Status in header byte count.

VerifyINFSupportAndData.c
issue 5-10332 - Test 5.16 - Update Evaluation Criteria for $F817, $F81C.
issue 5-10355 - Test 5.16 - Fails INF $F878 for Gas engines, but requirements say that it only applies to "D – MDV/MDDE OBD II, HD OBD FAIL if value is zero".
issue 5-10287 - $F898 (Recent) should be non-zero, $F899 (Lifetime) can be any value.

VerifyPIDSupportAndData.c
issue 5-10356 - Test 5.6 & 5.10 - DID $F471 decodes VGT_A_STA and VGT_B_STA incorrectly.
issue 5-10357 - Test 5.6 & 5.10 - In DID $F47A & $F48B, the references to "Diesel" or "D" (like in DPF) must be removed from the DID decode.
issue 5-10359 - Test 5.6, 5.10 - DID $F4BD decode says "Hybrid/EV Battery Temperature Data support", but it should say "HVESS Total Energy Throughput Data support".
issue 5-10158 - Test 11.5 must also check DIDs $F431/$F44E.



Revision 04.11.01

DetermineProtocol.c
	issue 5-10339 - IdentifyOBDProtocol() error message for SID $01 PID $00 incorrectly says "PID $01".

DoIP.c
	issue 5-10352 - Tests 12.8-12.11 Reconnecting to DoIP must include the $F810 DID request.

j1699.c
	Update version number.

j1699.h
	issue 5-10021 - Test 11.1, 11.2 & 11.7 - Support SMAD (INF $93) in Mfg. Specific Drive Cycle.  Add SMAD data masks for ECU Status flags
	issue 5-10347 - Expand Network Message logging to support large message… maybe up to 4K.
	issue 5-10354 - Test 10.10 is making a Functional Addressed request for the Readiness Groups, but it must be a Physically Addressed request.  Fix naming of DTC IM Readiness variables to DTC Readiness Group.

PIDTable.h
	issue 5-10348 - Test 6.4 is stuck in an infinite loop.  Fix handling of variable size PIDs, fix $F4D8 erroneous zero entry, add $F5xx PIDs.

ReadIni.c
	issue 5-10320 - Test 12.8 DoIP - DoIP reconnect not working, DHCP UDP Socket bind  gives Error: 10049: SOCKET 10049 - Cannot assign requested address.  Increase default bind delay.

ResetSIDResponseData.c
	issue 5-10334 - Test 10.10 - "WARNING: ECU 7E8 received unexpected response to SID $19 $06 DTC P0000 00 ExtData $93 (SMAD) request (Response not stored)" reported without an ECU 7E8 response.
	issue 5-10354 - Fix naming of DTC IM Readiness variables to DTC Readiness Group.

SaveSIDResponseData.c
	issue 5-10354 - Fix naming of DTC IM Readiness variables to DTC Readiness Group.

Test10_InUseCounters.c
	issue 5-10340 - Test 10.15 - Need to Test Results line to log file (it is a User action, which will always PASS).
	issue 5-10354 - Fix naming of DTC IM Readiness variables to DTC Readiness Group.

Test11_PerformanceCounters.c
	issue 5-10021 - Test 11.1, 11.2 & 11.7 - Support SMAD (INF $93) in Mfg. Specific Drive Cycle.
	issue 5-10354 - Fix naming of DTC IM Readiness variables to DTC Readiness Group.

Test12_ZEV.c
	issue 5-10337 - Test 12.2 & 12.6 - Functionally clear codes for DoCAN only.

VerifyConfirmedDTCData.c
	issue 5-10265 - DTC tests should FAIL if DTC format identifier != 4.

VerifyDTCExtData.c
	issue 5-10205 - Test 10.10, 10.15, 11.12 - Evaluate SMAD data.
	issue 5-10329 - Test 10.7 & 11.6 report the offending DTC as 'P000 00' when ECU response does not contain Test Results data in the WARNING and INFORMATION log entries.
	issue 5-10354 - Test 10.10 is making a Functional Addressed request for the Readiness Groups, but it must be a Phycially Addressed request.  Fix naming of DTC IM Readiness variables to DTC Readiness Group.
	issue 5-10363 - Print currently requested DTC IUMPR and SMAD to indicate progress

VerifyFFSupportAndData.c
	issue 5-10348 - Test 6.4 is stuck in an infinite loop.  Fix handling of variable size PIDs.

VerifyINFSupportAndData.c
	issue 5-10287 - Test 12.7 - Update F886, F887, F888, F889, F88A, F88B, F88C, F88D, F88F, F898 to not FAIL/WARN if recent 0.
	issue 5-10288 - Test 12.7 - Update F890 to not FAIL/WARN if 0.
	issue 5-10289 - Test 12.7 - Update F896 to not FAIL/WARN if 0.
	issue 5-10291 - Test 12.7 - Update F8AD to not FAIL/WARN if 0.
	issue 5-10333 - Test 5.16 - Update Evaluation Criteria for $F877.

VerifyPendingDTCData.c
	issue 5-10265 - DTC tests should FAIL if DTC format identifier != 4.

VerifyPermanentDTCData.c
	issue 5-10265 - DTC tests should FAIL if DTC format identifier != 4.

VerifyPIDSupportAndData.c
	issue 3-1117  - Test 10.2.2 - Make an exception for PID $01 to not test Values.
	issue 5-10292 - Test 12.7 - F4D6 values can be either zero or non-zero in test 12.6
	issue 5-10331 - Test 5.6, 5.10, 10.6 Update DIDs $F502, $F503, $F504, $F505

VerifyRIDSupportAndData.c
	issue 5-10335 - Test 5.7 - FAIL VerifyRIDSupportAndData() if there is no response to 31 01 E0 00 request if one or more ECUs supports EVAP Monitor (DID $F501 Data_D bit 0 == 1).



Revision 04.11.00

CheckIDSupport.c
	issue 5-10210 - J1979-3 says Functionally Addressed request are limited to Vehicle Identification, but Test 12 has some tests that are done with Functional Addressing.

ClearCodes.c
	issue 5-10297 - Test 5.3, 5.9, 9.23.4 Clear Codes - Check that ALL OBD II ECUs respond.

DetermineProtocol.c
	issue 5-10298 - Test 10.1 is not failing if there is a response to SID $01 PID $01.

DoIP.c
	issue 5-10323 - Test 12.8 DoIP fails to connect because bNetworkStarted and bRoutingActvation are both TRUE.

j1699.c
	Update version number.
	issue 5-10095 - Tests 6.4, 7.4, 8.4, 9.4 - Add Freeze Frame functionality for ICE.  Add flag to disable failure logging for Freeze Frame DID data.

j1699.h
	issue 5-10095 - Tests 6.4, 7.4, 8.4, 9.4 - Add Freeze Frame functionality for ICE.  Add flag to disable failure logging for Freeze Frame DID data.
	issue 5-10206 - Test 11.2 & 11.7 - Change evaluation criteria for IUMPR data using RGID.
	issue 5-10330 - increase size of DTC buffers.

LogPrint.c
	issue 5-10095 - Tests 6.4, 7.4, 8.4, 9.4 - Add Freeze Frame functionality for ICE.  Add flag to disable failure logging for Freeze Frame DID data.

PIDTable.h
	issue 5-10095 - Tests 6.4, 7.4, 8.4, 9.4 - Add Freeze Frame functionality for ICE.  Add PID lookup table for logging of Freeze Frame DID data.

RequestSID.c
	issue 5-10315 - Don't stop Tester Present on DoIP.
	issue 5-10183 - Test 5.5.2.2, 5.13, 10.3, 10.7, 11.1, 11.6, 11.12 - Do not FAIL if an ECU does not have DTCs that supports $91 Ext. Data, $92 Ext. Data, $93 Ext. Data. NEW PASS/FAIL/WARN criteria See 5.5.2.2.

ResetSIDResponseData.c
	issue 5-10206 - Test 11.2 & 11.7 - Change evaluation criteria for IUMPR data using RGID.

SaveSIDResponseData.c
	issue 5-10183 - Test 5.5.2.2, 5.13, 10.3, 10.7, 11.1, 11.6, 11.12 - Do not FAIL if an ECU does not have DTCs that supports $91 Ext. Data, $92 Ext. Data, $93 Ext. Data. NEW PASS/FAIL/WARN criteria See 5.5.2.2.
	issue 5-10206 - Test 11.2 & 11.7 - Change evaluation criteria for IUMPR data using RGID.
	issue 5-10297 - Test 5.3, 5.9, 9.23.4 Clear Codes - Check that ALL OBD II ECUs respond.
	issue 5-10303 - Test 5.17 - Reverse Order checks for Group Requests are allowing positive responses without DIDs.

Sockets.c
	issue 5-10323 - Test 12.8 DoIP fails to connect because bNetworkStarted and bRoutingActvation are both TRUE.

Test10_InUseCounters.c
	issue 5-10206 - Test 11.2 & 11.7 - Change evaluation criteria for IUMPR data using RGID.
	issue 5-10296 - Test 10.13 - This was the DID validation after the CARB Drive Cycle, but this is no longer part of the requirements. The DID evaluation must be removed.

Test11_PerformanceCounters.c
	issue 5-10206 - Test 11.2 & 11.7 - Change evaluation criteria for IUMPR data using RGID.

Test12_ZEV.c
	issue 5-10210 - J1979-3 says Functionally Addressed request are limited to Vehicle Identification, but Test 12 has some tests that are done with Functional Addressing.

Test9_NoFaultsAfter3DriveCycles.c
	issue 5-10312 - Test 9.1 Need to allow for User Fail, that is continue with MIL ON (e.g., Yes, No, Fail).

VehicleReport.c
	issue 5-10095 - Tests 6.4, 7.4, 8.4, 9.4 - Add Freeze Frame functionality for ICE.  Commonize PID verification functions.
	issue 5-10299 - Physically Addressed requests must FAIL if the requested item is supported, but no response is received.

VerifyDTCExtData.c
	issue 5-10206 - Test 11.2 & 11.7 - Change evaluation criteria for IUMPR data using RGID.
	issue 5-10310 - Tests 5.5, 5.13, 10.7, 11.6 - Test Results (Test Value, Min Test Limit, or Max Test Limit) do not have the appropriate Unit/Scaling applied.

VerifyFFSupportAndData.c
	issue 5-10095 - Tests 6.4, 7.4, 8.4, 9.4 - Add Freeze Frame functionality for ICE.  Log scaled PID data.

VerifyINFSupportAndData.c
	issue 5-10278 - Test 9.19 - INF $F817, INF $F818, and other evaluations are returning FAIL, but not logging it.
	issue 5-10286 - Test 12.7 - Number of decimal places in Engineering Values is incorrect.
	issue 5-10299 - Physically Addressed requests must FAIL if the requested item is supported, but no response is received.
	issue 5-10316 - $F898 and $F899 logging FAIL if counters != 0 but not counting as FAILURE.
	issue 5-10317 - Test 9.19 must FAIL if the FC_R value in $F817 is not equal 0.
	issue 5-10318 - Log entry for $F819 incorrectly list $F918 in text.
	issue 5-10326 - WARN for both ICE and ZEV if $F810 != 1.
	issue 5-10327 - Test 12.8 - There is no requirement that there only be one CALID. The software must not WARN if there is more than one CALID.
	issue 5-10328 - Test 12.8 - There is no requirement to support or check CVN so the check/WARNING/FAILURE must be removed.
	issue 5-10338 - Correct the handling of 'Not Supported' for $F842, $F844, and $F846 for PTOERT and PTOFC.


VerifyPIDSupportAndData.c
	issue 5-10095 - Tests 6.4, 7.4, 8.4, 9.4 - Add Freeze Frame functionality for ICE.  Make PID evaluations into functions.
	issue 5-10321 - Test 12.3 & 12.6 - DID $F4D0 bits 1 & 2 are required to both be 1 in V4.10 of document. 'Reserve Battery Capacity' should be an 'if equipped' option.



Revision 04.10.00

CheckIDSupport.c
	issue 5-10280 - Range linking $F4xx to $F5xx is not allowed. This removes the allowance implemented in Issue #5-10059.

ClearCodes.c
	issue 5-10101 - Test 5.9/12.5 (KOER) Clear Codes did not fail Light Duty Diesel for mixed Pos and Neg responses, but did fail Light Duty Gas (as expected).

DetermineProtocol.c
	issue 5-10098 - Test 10.11 - Crash because ECU IDs don't match original list.

DHCP.c
	issue 5-10306 - Test 12.1 - Sometimes gets a 'Error: 10049: SOCKET 10049 - Cannot assign requested address'. Add socket bind delay and retry.

DoIP.c
	issue 5-10306 - Test 12.1 - Sometimes gets a 'Error: 10049: SOCKET 10049 - Cannot assign requested address'. Add socket bind delay and retry.
	issue 5-10182 - Fix Socket communication problems when J2534 Interface disconnects.  Add connect delay and retry

j1699.c
	Update version number.

j1699.h
	issue 5-10282 - Test 5.5 & 5.13 - $19 $06 ($92) must allow for more than 10 Test Results.
	issue 5-10279 - Update DID Evaluations from J1699-5 V4.10. Add MAD ($F879) storage for future SMAD evaluation.

ReadIni.c
	issue 5-10306 - Test 12.1 - Sometimes gets a 'Error: 10049: SOCKET 10049 - Cannot assign requested address'. Add socket bind delay and retry.
	issue 5-10182 - Fix Socket communication problems when J2534 Interface disconnects.  Add connect delay and retry

RequestSID.c
	issue 5-10241 - Tests that get Extended Data ($91, $92, $93) should FAIL if a request gets a NRC $31 OR if the ECU responds positively if that DTC is not supported.
	issue 5-10272 - Only use ECUs that respond positively to $22 $F810 with data = 01.

SaveSIDResponseData.c
	issue 5-10272 - Only use ECUs that respond positively to $22 $F810 with data = 01.
	issue 5-10307 - For SID $1A Ext Data $92, gstResponse[EcuIdx].DTCIUMPRList should be gstResponse[EcuIdx].DTCTestResultList and MAX_DTCIUMPR_COUNT should be MAX_DTCTESTRESULT_COUNT

Test10_InUseCounters.c
	issue 5-10283 - Delete the DTC Extended data summary statements.

Test11_PerformanceCounters.c
	issue 5-10283 - Delete the DTC Extended data summary statements.
	issue 5-10294 - Test 11.2 - IUMPR results prints from superset of IUMPR DTCs, not ECU specific list.
	issue 5-10295 - Test 11.7 - FAILURE 'Monitor has not changed since Test 10.10' needs to include the text "IUMPR" (to distinguish from SMAD, which will be added later). As improve OBDCOND failure information.
	issue 5-10301 - Test 11.2 will not complete even though summary data in the J1699-5 log show 11.2 nothing left to do.

Test12_ZEV.c
	issue 5-10210 - J1979-3 says Functionally Addressed request are limited to Vehicle Identification, but Test 12 has some tests that are done with Functional Addressing.
	issue 5-10263 - Test 12.11 - Test logic is incorrect, looping must be removed and it must FAIL ECUs that do not respond to a Pending DTC request and not make a Confirmed DTC request.
	issue 5-10281 - Test 12.11 - Remove text "*** Further ZEV Tests NOT CURRENTLY IMPLEMENTED ***" from Test12_ZEV.c, as there are no tests beyond Test 12.11.

Test5_NoDTC.c
	issue 5-10283 - Delete the DTC Extended data summary statements.

Test8_FaultRepaired.c
	issue 5-10283 - Delete the DTC Extended data summary statements.

VehicleReport.c
	issue 5-10210 - J1979-3 says Functionally Addressed request are limited to Vehicle Identification, but Test 12 has some tests that are done with Functional Addressing.

VerifyConfirmedDTCData.c
	issue 5-10285 - Test 9.8 should not FAIL if 'Pending DTC' bit is set in the Confirmed DTC Status.

VerifyDTCExtData.c
	issue 5-10236 - Tests that get Extended Data ($91, $92, $93) should ask each ECU for only the DTC Extended Data that the ECU supports.
	issue 5-10295 - FAILURE needs to include the text "IUMPR" (to distinguish from SMAD, which will be added later).
	issue 5-10302 - Test 10.3 - Extended Data Global Counters will not be set if there is an error in getting Extended Data. This is an issue for Test 11.1.
	issue 5-10308 - Add SMAD List Count limit check.

VerifyFFSupportAndData.c
	issue 5-10311 - When there is no FFDTC data, GetEcuId ( EcuIdx ) should be GetEcuId ( EcuIdx2 ).  Also improve information logged when there is no FFDTC data.

VerifyINFSupportAndData.c
	issue 5-10210 - J1979-3 says Functionally Addressed request are limited to Vehicle Identification, but Test 12 has some tests that are done with Functional Addressing.
	issue 5-10278 - Test 9.19 - INF $F817, INF $F818, and other evaluations are returning FAIL, but not logging it.
	issue 5-10279 - Update DID Evaluations from J1699-5 V4.10. Add $F877 not supported check and MAD ($F879) storage for future SMAD evaluation
	issue 5-10290 - Test 12.7 - F898 evaluation is wrong in test 12.7. According to the document the "Recent Data must reset to zero post code clear. FAIL if any counter is non zero". The software warns if any value is zero.
	issue 5-10314 - $F8A0 should not be included in the $F885-$F8AE support requirement check

VerifyPendingDTCData.c
	issue 5-10210 - J1979-3 says Functionally Addressed request are limited to Vehicle Identification, but Test 12 has some tests that are done with Functional Addressing.

VerifyPIDSupportAndData.c
	issue 5-10117 - Test 12.6 Fails because $F4B2 is 0, but there is no requirement to evaluate the DID content.
	issue 5-10223 - Test 12.3/12.6 - The 'Required Value' for DID $F4D0 is unclear, what is to be checked. What if the ECU indicates none of the fields are supported?
	issue 5-10224 - Test 12.3/12.6 - The 'Required Value' for DID $F4D1 is unclear. J1979DA seems to indicate that they should only report a value when a charger is connected.
	issue 5-10279 - Update DID Evaluations from J1699-5 V4.10.  $F4AD, $F4B0, $F4D7 evaluation, $F49A, $F4AF, $F4D3 support requirement
	issue 5-10280 - Range linking $F4xx to $F5xx is not allowed. This removes the allowance implemented in Issue #5-10059.  Also $F5xx to $F6xx.
	issue 5-10284 - Test 12.3 & 12.6 - Should only evaluate the DIDs listed in the table. Other DID that are supported by the ECU should be decoded and logged, but not evaluated.



Revision 04.08.01
	CheckIDSupport.c
	issue 5-10226 - Evaluation of next unsupported DIDSupported DID is not correct for $xx00 and $xxE0.

	DoIP.c
	issue 5-10259 - Routing Activation is only being sent if bNetworkStarted == FALSE, but it should be bRoutingActivated == FALSE.
	issue 5-10262 - Test 12 DoIP - DoIP reconnect works sometimes: The script sends a Routing Activation request even thou the connection is not closed. Vehicle decides to close the TCP socket due to this.
	issue 5-10261 - Test 12 DoIP - DoIP reconnect works sometimes: Often fails with “TCP Socket connect Error: 10048: SOCKET 10048 - Address already in use” even thou the TCP connection is closed.
	                Improve DoIP error message descriptions and add retry with closesocket.

	j1699.c
	Update version number.

	j1699.h
	issue 5-10238 - Test 10.10 - SMAD data is being decoded as 3 bytes, when it is actually 2 bytes: MINI NUMERATOR (1 byte) and ACTIVITY RATIO (1 byte).  Remove DenomCounts also store Activity Ratio as float.
	issue 5-10095 - Tests 6.4, 7.4, 8.4, 9.4 - Add Freeze Frame functionality for ICE.

	LogPrint.c
	issue 5-10269 - Test 8.3 - "FAILURE: Verify DTC stored data unsuccessful" not followed by new line character.
                    Also "j1699-5 software version in log file (%s) does not match currently running version (%s)" (and some other FAILURE/WARNING messages) missing newline.

	RequestSID.c
	issue 5-10240 - NRC processing for UDS messages on DoIP must be consistent with ISO 15765.
	issue 5-10246 - ISO 15765 message requests for SID $03, $04, and $07 produce a message with an extra byte, which is incorrect.
	issue 5-10250 - Test 12 - DoIP NAK for a Diagnostic Request for $22 $F810 causes software to crash.
	issue 5-10267 - Test 12 - DoIP NRC $78 are not extending the time for the ECU to respond.
	issue 5-10268 - Fix code in RequestSID ISO 15765 NRC processing for SID $22.  "pstReqMsg->u.DID[0] >= 0xF8FF" should be "pstReqMsg->u.DID[0] <= 0xF8FF."

	ResetSIDResponseData.c
	issue 5-10095 - Tests 6.4, 7.4, 8.4, 9.4 - Add Freeze Frame functionality for ICE.

	SaveSIDResponseData.c
	issue 5-10095 - Tests 6.4, 7.4, 8.4, 9.4 - Add Freeze Frame functionality for ICE.
	issue 5-10238 - Test 10.10 - SMAD data is being decoded as 3 bytes, when it is actually 2 bytes: MINI NUMERATOR (1 byte) and ACTIVITY RATIO (1 byte).  Remove DenomCounts.
	issue 5-10258 - Test 5.7 & 5.15 reports 'SID $31 response data exceeded buffer size', S/W needs to account for RoutineInfo byte.
	issue 5-10260 - Test 12.3 DoIP - "ECU 0 has already responded" warning, but there is no ECU 0?

	Sockets.c
	issue 5-10261 - Test 12 DoIP - DoIP reconnect works sometimes: Often fails with “TCP Socket connect Error: 10048: SOCKET 10048 - Address already in use” even thou the TCP connection is closed. 

	Test10_InUseCounters.c
	issue 5-10144 - Test 10.13 - Add ignition cycle before SMAD request.
	issue 5-10238 - Test 10.10 - SMAD data is being decoded as 3 bytes, when it is actually 2 bytes: MINI NUMERATOR (1 byte) and ACTIVITY RATIO (1 byte).  Remove DenomCounts.
	issue 5-10239 - Test 10.12 and 11.2 must include the FTB when writing the DTC to the log file for IUMPR and SMAD.
	issue 5-10255 - Re-entering the ICE Dynamic Tests, Test 11.7 fails indicating that no monitors have changed from Test 10.10.
	issue 5-10273 - Test 10.10 is crashing for PHEV.
	issue 5-10275 - Test 10.14  Move FEOCNTR check before new SMAD ignition cycle.


	Test11_PerformanceCounters.c
	issue 5-10239 - Test 10.12 and 11.2 must include the FTB when writing the DTC to the log file (and on-screen) for IUMPR and SMAD.
	issue 5-10254 - Test 11.7 - FAILURE 'Monitor has not changed since Test 10.10' needs to also indicate the associated DTC and FTB.
	                Also Test 11.2 - FAILURE "An OBD counter which was non-zero in test 11.7 is now zero" needs to also indicate the associated DTC and FTB
	issue 5-10255 - Re-entering the ICE Dynamic Tests, Test 11.7 fails indicating that no monitors have changed from Test 10.10.
	issue 5-10251 - Add IUMPR cycle count on-screen for Test 11.2.

	Test12_ZEV.c
	issue 5-10231 - Test 12 - Remove "MIL" checks and text.
	issue 5-10263 - Test 12.11 - Test logic is incorrect, it must FAIL ECUs that do not respond to a Pending DTC request and not make a Confirmed DTC request.
	issue 5-10276 - Test 12.8 - change prompt text from "for only one" to "in a propulsion-related", to match document.

	Test5_NoDTC.c
	issue 5-10095 - Test 5.11 - Remove Freeze Frame DTC check
	issue 5-10277 - Test 5.13 - Ext Data $19 $1A $92 requests should be physically addressed only.

	Test6_PendingDTC.c
	issue 5-10095 - Tests 6.4, 7.4, 8.4, 9.4 - Add Freeze Frame functionality for ICE.

	Test7_ConfirmedDTC.c
	issue 5-10095 - Tests 6.4, 7.4, 8.4, 9.4 - Add Freeze Frame functionality for ICE.

	Test8_FaultRepaired.c
	issue 5-10095 - Tests 6.4, 7.4, 8.4, 9.4 - Add Freeze Frame functionality for ICE.

	Test9_7to17_PermanentCodes.c
	issue 5-10273 - Test 10.10 is crashing for PHEV.

	Test9_NoFaultsAfter3DriveCycles.c
	issue 5-10095 - Tests 6.4, 7.4, 8.4, 9.4 - Add Freeze Frame functionality for ICE.

	VerifyConfirmedDTCData.c
	issue 5-10249 - Test 12 - The DTC Status bit have all changed.
	issue 5-10253 - Test 9.8 Confirmed DTC Status bits have changed.
	issue 5-10256 - Change text "Failure Type" to "FTB" to aid in locating FAILURES in log file.  Display FTB as part of DTC with no label.
	issue 5-10270 - Tests 6.2, 6.3, 7.2, 7.3, 8.3, 9.3 - Make the Evaluation Criteria for DTC Status Bit #5 be 'don't care'.

	VerifyDTCExtData.c
	issue 5-10238 - Test 10.10 - SMAD data is being decoded as 3 bytes, when it is actually 2 bytes: MINI NUMERATOR (1 byte) and ACTIVITY RATIO (1 byte).  Remove DenomCounts.
	issue 5-10248 - WARN for Multiple Test results; Verify Values when required.
	issue 5-10255 - Re-entering the ICE Dynamic Tests, Test 11.7 fails indicating that no monitors have changed from Test 10.10.
	issue 5-10256 - Change text "Failure Type" to "FTB" to aid in locating FAILURES in log file.  Display FTB as part of DTC with no label.

	VerifyFFSupportAndData.c
	issue 5-10095 - Tests 6.4, 7.4, 8.4, 9.4 - Add Freeze Frame functionality for ICE.
	                PARTIAL: Requests and Receives Freeze Frame data but does not decode or evaluate

	VerifyINFSupportAndData.c
	issue 3-1115  - Test 5.17 - Valid INF $0A responses with ECU Acronyms that are less than 4 characters will not have the ECU Names logged.
	issue 5-10229 - Test 12.7 - Failure on the DIDSupported DID evaluation generates the FAILURE message "Problems verifying PID $F4xx supported data.".
	issue 5-10264 - Test 12.7 Add evaluation criteria for INF > $F884 (NOTE:  Functions to evaluate these INFs were coded a while ago but they were never called, therefore any changes in them are fixing problems no user would have encountere).
	issue 5-10273 - Test 10.10 is crashing for PHEV.

	VerifyPendingDTCData.c
	issue 5-10249 - Test 12 - The DTC Status bit have all changed.
	issue 5-10256 - Change text "Failure Type" to "FTB" to aid in locating FAILURES in log file.  Display FTB as part of DTC with no label.
	issue 5-10270 - Tests 6.2, 6.3, 7.2, 7.3, 8.3, 9.3 - Make the Evaluation Criteria for DTC Status Bit #5 be 'don't care'.

	VerifyPermanentDTCData.c
	issue 5-10256 - Change text "Failure Type" to "FTB" to aid in locating FAILURES in log file.  Display FTB as part of DTC with no label.

	VerifyPIDSupportAndData.c
	issue 5-10114 - Test 12.3 Fails because $F44A,4B is not supported. J1699-5 (V4.6) indicates that there is a discrepancy  between 1968.2 and 1968.5. The software follows the J1699-5 (V4.6).
	issue 5-10243 - In DID evaluations, HEV_BAT_A in DID F49A is not required for US.
	issue 5-10257 - Test 5.6 & 5.10 - DID $F4DC is 'if Equipped', so do not FAIL if not supported.
	issue 5-10266 - Test 12.3 - $F430 & $F431 DID Evaluations can fall into the Test 5.10 logic and creating an incorrect result.
	                $F421,30,4D,4E support not required for ZEVs and ACC-II Credit earning PHEVs and Must be zero post code clear, if supported.

	VerifyRIDSupportAndData.c
	issue 5-10252 - Test 5.7 and 5.15 does not FAIL if EVAP supported in $F501 but $E001 not supported for SID $31.
	issue 5-10274 - Fix RID data display.


	

Revision 04.08.00
	ConnectProtocol.c
	issue 5-10222 - Correct DHCP discovery process.  Move definition of AdapterInfo so that it is available outside this file.

	DHCP.c
	issue 5-10222 - Correct DHCP discovery process.  Allow ignoring of duplicate DHCP Discover messages with the same Transaction ID or from the Tester Device. 

	DHCP.h
	issue 5-10222 - Correct DHCP discovery process.  Add Transaction ID to DHCPEntity structure and add extern for AdapterInfo.

	DoIP.c
	issue 5-10222 - Correct DHCP discovery process.  Allow DHCP server to be disabled.
	issue 5-10163 - Ignore all but the first Vehicle Identification message.
	issue 5-10214 - Retry message write on socket closed by peer error.

	j1699.c
	Update version number.

	j1699.h
	issue 5-10193 - Test 8.3 & 9.3 Fails if PendingDTC, Test Failed This Operation Cycle, and Test Failed status are not indicated.  Add DTC State machine definitions.
	issue 5-10184 - Test 5.5.3 & 5.13 FAILs if an ECU report more than one result for $19 $06 DTC $92.  Change DTC Test Result structure to allow for multiple test results.
	issue 5-10222 - Correct DHCP discovery process.  Add variable to allow DHCP server to be disabled.

	ReadIni.c
	issue 5-10222 - Correct DHCP discovery process.  Add section to allow DHCP server to be disabled.

	ResetSIDResponseData.c
	issue 5-10184 - Test 5.5.3 & 5.13 FAILs if an ECU report more than one result for $19 $06 DTC $92.  Clear DTC Test Results structure with multiple test results.

	SaveSIDResponseData.c
	issue 5-10160 - Test 10.10 - Error message for bad IUMPR or SMAD data not logging the DTC from the Request.  Save the DTC even if the rest of the data is not there.
	issue 5-10184 - Test 5.5.3 & 5.13 FAILs if an ECU report more than one result for $19 $06 DTC $92.  Save DTC Test Results structure with multiple test results.
	issue 5-10194 - Tests 5.7 & 5.15 Request message is incorrect and no response not flagged as error.  Fix handling of RID messages.

	Test10_InUseCounters.c
	issue 5-10193 - Test 8.3 & 9.3 Fails if PendingDTC, Test Failed This Operation Cycle, and Test Failed status are not indicated.  Add DTC State to Verify DTC Data function calls.
	
	Test11_PerformanceCounters.c
	issue 5-10193 - Test 8.3 & 9.3 Fails if PendingDTC, Test Failed This Operation Cycle, and Test Failed status are not indicated.  Add DTC State to Verify DTC Data function calls.

	Test12_ZEV.c
	issue 5-10228 - Test 12 - Change "Engine Running", "PSA On", and "PSA = TRUE (ON)" to "PSA Active". Change "Engine OFF" to "PSA Inactive".
	issue 5-10193 - Test 8.3 & 9.3 Fails if PendingDTC, Test Failed This Operation Cycle, and Test Failed status are not indicated.  Add DTC State to Verify DTC Data function calls.

	Test5_NoDTC.c
	issue 5-10123 - Remove physically addressed Clear Codes.
	issue 5-10193 - Test 8.3 & 9.3 Fails if PendingDTC, Test Failed This Operation Cycle, and Test Failed status are not indicated.  Add DTC State to Verify DTC Data function calls.

	Test6_PendingDTC.c
	issue 5-10204 - Test 6.1 - Replace "Let idle." with "Let idle for one minute or whatever time it takes to set a pending DTC."
	issue 5-10193 - Test 8.3 & 9.3 Fails if PendingDTC, Test Failed This Operation Cycle, and Test Failed status are not indicated.  Add DTC State to Verify DTC Data function calls.

	Test7_ConfirmedDTC.c
	issue 5-10193 - Test 8.3 & 9.3 Fails if PendingDTC, Test Failed This Operation Cycle, and Test Failed status are not indicated.  Add DTC State to Verify DTC Data function calls.

	Test8_FaultRepaired.c
	issue 5-10193 - Test 8.3 & 9.3 Fails if PendingDTC, Test Failed This Operation Cycle, and Test Failed status are not indicated.  Add DTC State to Verify DTC Data function calls.

	Test9_7to17_PermanentCodes.c
	issue 5-10193 - Test 8.3 & 9.3 Fails if PendingDTC, Test Failed This Operation Cycle, and Test Failed status are not indicated.  Add DTC State to Verify DTC Data function calls.
	issue 5-10244 - Test 9.16 can display zeros for IGN_CNTR and OBDCOND ($F882) because DID-Support DID $F880 may be cleared making it appear unsupported. Refresh $F8xx DID-Support DIDs.
	issue 5-10245 - Test 9.17 can falsely fail if there was a failure in Test 9.16.  Clear bSubTestFailed before test.

	Test9_NoFaultsAfter3DriveCycles.c
	issue 5-10193 - Test 8.3 & 9.3 Fails if PendingDTC, Test Failed This Operation Cycle, and Test Failed status are not indicated.  Add DTC State to Verify DTC Data function calls.

	VerifyConfirmedDTCData.c
	issue 5-10193 - Test 8.3 & 9.3 Fails if PendingDTC, Test Failed This Operation Cycle, and Test Failed status are not indicated.  Update DTC Status bit checks.
	issue 5-10196 - Test 12.8 - DTC Status bit 5 and 7 are optional for ZEVs and J1699-5 should not check for these.

	VerifyDTCExtData.c
	issue 5-10184 - Test 5.5.3 & 5.13 FAILs if an ECU report more than one result for $19 $06 DTC $92.  Save and log DTC Test Results structure with multiple test results.
	issue 5-10237 - Test 5.5 & 5.13 - The Test Results is being converted incorrectly.  Handle big-endian/little endian mismatch.

	VerifyINFSupportAndData.c
	issue 5-10088 - In Test 5.16 (can be 200 sec after clear codes) a Warning/Failure for EOE-A ($F818, $F841, $F845) may need to allow for 0.  Remove INF $F841 EOE-A and $F845 EOE-L 0 check

	VerifyMILData.c
	issue 5-10216 - Test 5.4.1 - When there is only 1 ECU and it responds correctly to the $22 $F501 Physically Addressed request, the error "FAILURE: Number of PID $F501 responses in error (2 responses, 1 to 1 expected" is generated..  Clear gNumOfECUsResp before looping RequestSID_PhysicallyAddressed_Single to correctly calculate number of responders.
	
	VerifyPendingDTCData.c
	issue 5-10193 - Test 8.3 & 9.3 Fails if PendingDTC, Test Failed This Operation Cycle, and Test Failed status are not indicated.  Update DTC Status bit checks.
	issue 5-10196 - Test 12.8 - DTC Status bit 5 and 7 are optional for ZEVs and J1699-5 should not check for these.

	VerifyPermanentDTCData.c
	issue 5-10193 - Test 8.3 & 9.3 Fails if PendingDTC, Test Failed This Operation Cycle, and Test Failed status are not indicated.  Update DTC Status bit checks.

	VerifyPIDBurstSupport.c
	issue 5-10203 - Test 5.19 - Burst test must use DIDs $F800 and $F810.

	VerifyPIDSupportAndData.c
	issue 5-10233 - Tests 5.6 and 5.10 - DID $F48F fails if the value is >-100, but there is not requirement for this.  Remove $F48F PM11 < -100 check.
	issue 5-10202 - Add $F4DC minimum support check, Update $F40D support requirements, Add $F482, $F489, $F48A, $F4DC support requirements.
	issue 5-10103 - Test 11.5 why are all supported I/M Readiness bits not being checked for 'complete'? Only a few are being flagged for failure.
	                Update evaluation of $F501 Data F Bit 0 (CSER_SUP),
	                                           Data B Bit 6 (CCM_RDY),
	                                           Data B Bit 7 (COOL_RDY),
	                                           Data C Bit 4 (CAT_RDY),
	                                           Data C Bit 5 (HCCAT_RDY),
	                                           Data C Bit 6 (HCAT_RDY),
	                                           Data C Bit 7 (NCAT_RDY),
	                                           Data D Bit 4 (EVAP_RDY),
	                                           Data D Bit 5 (AIR_RDY),
	                                           Data D Bit 6 (BP_RDY),
	                                           Data D Bit 7 (PF_RDY),
	                                           Data E Bit 4 (EGS_RDY),
	                                           Data E Bit 5 (CV_RDY),
	                                           Data E Bit 6 (EGR_RDY),
	                                           Data E Bit 7 (VVT_RDY),
	                                           Data F Bit 3 (DOR_RDY),
	                                           Data F Bit 5 (CSER_RDY),
	                                           Data F Bit 6 (NAC_RDY),
	                                           Data F Bit 7 (OTH_RDY).
	issue 5-10138 - Tests 10.6 - Add $F501 Data_D Bit 4 may be 0 or 1 for EOBD Gasoline Engines.
	issue 5-10139 - Tests 10.6 - Add $F501 Data_F Bit 6 must be 1 for Compression Ignition Engines.
	
	VerifyRIDSupportAndData.c
	issue 5-10194 - Tests 5.7 & 5.15 Request message is incorrect and no response not flagged as error.  Fix RID storing of Control Type and ID to use bytes instead of words.




Revision 04.06.03
	CheckMIL.c
	issue 5-10179 - Move request for input in Prompts to next line (Do the newline in Log function instead of each call with ENTER_PROMPT)
	
	ConnectProtocol.c
	issue 5-10189 - Test 12.8 crashes for no apparent reason with DoIP. (Address data encapsulated in a structure for maintainability)

	DetermineProtocol.c
	issue 5-10179 - Move request for input in Prompts to next line. (Do the newline in Log function instead of each call with ENTER_PROMPT)
	issue 5-10189 - Test 12.8 crashes for no apparent reason with DoIP. (Protocol detection clean up)
	
	DHCP.c
	issue 5-10166 - J1699-5 not acting as a DHCP Server. (File added to handle DHCP transactions)
	
	DHCP.h
	issue 5-10166 - J1699-5 not acting as a DHCP Server. (File added to handle DHCP transactions)

	DisconnectProtocol.c
	issue 5-10169	Test 12 - Don't call PassThruIoctl(CLEAR_MSG_FILTERS) for DoIP, it is not allowed. (Don't call PassThruIoctl(CLEAR_MSG_FILTERS) if a protocol was not found (gProtocolIdx is max))
	issue 5-10189 - Test 12.8 crashes for no apparent reason with DoIP. (CloseSockets updated for maintainability)


	DoIP.c
	issue 5-10163 - Test 12.1 - DoIP Vehicle Identification response is constantly sent by vehicle causing software to be in an infinate loop (waiting for vehicle to stop responding).
	issue 5-10166 - J1699-5 not acting as a DHCP Server. (Add DHCP server function call)
	issue 5-10189 - Test 12.8 crashes for no apparent reason with DoIP. (Make common code into functions and encapsulate address data for maintainability and portabiliy)
	
	DoIP.h
	issue 5-10166 - J1699-5 not acting as a DHCP Server. (Some definitions moved to Socket.h for portability)
	issue 5-10189 - Test 12.8 crashes for no apparent reason with DoIP. (Some definitions moved to Socket.h for portability)

	j1699.c
	Update version number.
	issue 5-10179 - Move request for input in Prompts to next line. (Do the newline in Log function instead of each call with ENTER_PROMPT)

	LogMsg.c
	issue 5-10189 - Test 12.8 crashes for no apparent reason with DoIP. (RcvdIPAddress renamed to RcvdIPAddressString to match changes made for maintainablity)

	LogPrint.c
	issue 5-10179 - Move request for input in Prompts to next line. (Do the newline in Log function instead of each call with ENTER_PROMPT)
	issue 5-10157 - Re-entering the Dynamic Test for HD OBD when Model Year and Engine Certification Year do not match, generates a FAILURE. (Compare the same type of Model Year (entered vs stored VIN and entered vs stored Engine Certification))

	RequestSID.c
	issue 5-10198 - Response time for ISO 15765 messages is set to 100ms, it should be 50ms.
	issue 5-10199 - NRC processing on ISO 15765 for First Frame Indications does not account for $78 extended timing.
	issue 5-10188 - Support UDS NRC evaluation for DoIP messages.
	
	Sockets.c
	issue 5-10166 - J1699-5 not acting as a DHCP Server. (File added to consolidate common socket functions)
	issue 5-10189 - Test 12.8 crashes for no apparent reason with DoIP. (File added to consolidate common socket functions)

	Sockets.h
	issue 5-10166 - J1699-5 not acting as a DHCP Server. (File added to consolidate common socket definitions)
	issue 5-10189 - Test 12.8 crashes for no apparent reason with DoIP. (File added to consolidate common socket definitions)
	
	Test10_InUseCounters.c
	issue 5-10179 - Move request for input in Prompts to next line. (Do the newline in Log function instead of each call with ENTER_PROMPT)
	issue 5-10180 - Prompt for VIN file Name in Dynamic Tests is not reading correctly.
	
	Test11_PerformanceCounters.c
	issue 5-10179 - Move request for input in Prompts to next line. (Do the newline in Log function instead of each call with ENTER_PROMPT)

	Test12_ZEV.c
	issue 5-10179 - Move request for input in Prompts to next line. (Do the newline in Log function instead of each call with ENTER_PROMPT)
	issue 5-10189 - Test 12.8 crashes for no apparent reason with DoIP. (Add CheckDoIPChannel at user prompts to ensure that vehicle socket is still connected (in case of long delay or power cycle))
	
	Test5_NoDTC.c
	issue 5-10179 - Move request for input in Prompts to next line. (Do the newline in Log function instead of each call with ENTER_PROMPT)

	Test6_PendingDTC.c
	issue 5-10179 - Move request for input in Prompts to next line. (Do the newline in Log function instead of each call with ENTER_PROMPT)

	Test7_ConfirmedDTC.c
	issue 5-10179 - Move request for input in Prompts to next line. (Do the newline in Log function instead of each call with ENTER_PROMPT)

	Test8_FaultRepaired.c
	issue 5-10179 - Move request for input in Prompts to next line. (Do the newline in Log function instead of each call with ENTER_PROMPT)

	Test9_7to17_PermanentCodes.c
	issue 5-10179 - Move request for input in Prompts to next line. (Do the newline in Log function instead of each call with ENTER_PROMPT)

	Test9_NoFaultsAfter3DriveCycles.c
	issue 5-10179 - Move request for input in Prompts to next line. (Do the newline in Log function instead of each call with ENTER_PROMPT)
	issue 5-10197 - Test 9.18, Engine Running Vehicle Information validation was removed from document, remove functionality from software.
	
	VehicleReport.c
	issue 5-10179 - Move request for input in Prompts to next line. (Do the newline in Log function instead of each call with ENTER_PROMPT)

	VerifyINFSupportAndData.c
	issue 5-10179 - Move request for input in Prompts to next line. (Do the newline in Log function instead of each call with ENTER_PROMPT)
	issue 5-10218 - Remove redundant check in evaluation of $F845
	
	VerifyMILData.c
	issue 5-10179 - Move request for input in Prompts to next line. (Do the newline in Log function instead of each call with ENTER_PROMPT)
	
	VerifyPIDSupportAndData.c
	issue 5-10100 - All DID check tests, there is no requirement that either $F492 or $F4B1 be supported.
	issue 5-10107 - $F4CB says FAIL in doc but software WARNs, but allows for 'if equipped'. S/W should FAIL on values, but not if supported.
	issue 5-10161 - Test 5.6 & 5.10 - DID $F49A evaluation is testing HEV_BATT_A, but it should be testing HEV_BATT_V. (Remove value evaluation, check support only)
	issue 5-10162 - Test 5.6 - DID $F4A5 FAILURE message lists a bad DID number.
	issue 5-10178 - Do not decode or evaluate DIDs $F401, $F402, or $F441.
	issue 5-10179 - Move request for input in Prompts to next line. (Do the newline in Log function instead of each call with ENTER_PROMPT)
	issue 5-10187 - DID decode for $F441 displays DID number as 4F41 for some bits.
	issue 5-10190 - Test 12 - The $F4B9 transformation to engineering values and units are incorrect.
	issue 5-10191 - Test 12 - The $F4D4 transformation to engineering values is incorrect.
	issue 5-10192 - Test 12 - The $F4B2 Name and units are incorrect.
	issue 5-10213 - Test 12.6 should not evaluate the contents of DID $F44E.
	
	VerifyVehicleState.c
	issue 5-10179 - Move request for input in Prompts to next line. (Do the newline in Log function instead of each call with ENTER_PROMPT)




Revision 04.06.02
	DetermineProtocol.c
	issue 5-10185 - GetEcuId checks all received ECU structures, not just the number of ECUs entered by the user.

	DoIP.c
	issue 5-10185 - Move some defines to DoIP.h to allow use outside this file.

	DoIP.h
	issue 5-10185 - Move some defines from DoIP.c to allow use by other files.

	j1699.c
	Update version number.

	RequestSID.c
	issue 5-10185 - Do not save ECU ID $E000 (functional address) to a received ECU structure.

	VerifyECUCommunication.c
	issue 5-10185 - VerifyECUCommunication logs all received ECU IDs, not just the number of ECUs entered by the user.




Revision 04.06.01
	ConnectProtocol.c
	issue 5-10164 - J2534 Interface not accepting Connect Flags when both Option1 and Option2 bits are set (even though this is VALID).  Change Auto-Detect value to 0x00000000, instead of 0x00030000.
	issue 5-10181 - Improve network socket maintenence.


	DetermineProtocol.c
	issue 5-10175 - Test 12 - For DoIP, logs a "Current protocol is not allowed for UDS" FAIURE, which is incorrect. Remove outdated protocol limitation.
	issue 5-10174 - Test 12 - Support up to 239 ECU for DoIP.
	issue 5-10182 - temporary work-around to prevent socket communication problems when j2634 device disconnects.

	DisconnectProtocol.c
	issue 5-10169 - Test 12 - Don't call PassThruIoctl(CLEAR_MSG_FILTERS) for DoIP, it is not allowed.
	issue 5-10182 - temporary work-around to prevent socket communication problems when j2634 device disconnects.

	DoIP.c
	issue 5-10165 - Test 12 - Initialize bNetworkStarted in DoIP.c.
	issue 5-10172 - Test 12 - Some DoIP ECU responses are not being process or logged.  Fix received data storage buffer handling to prevent data loss.
	issue 5-10171 - Test 12 - Process Vehicle ID response and decode; if a response is received, do not repeat request 3 times.  Allow variable data size responses.
	issue 5-10168 - Test 12 - Log RX and TX of Routing Activation message
	issue 5-10173 - Test 12 - Don't repeat transmission of the Routing Activation, if a response was received.  Check for the same number of responses as Entity Status, not number of ECUs.
	issue 5-10181 - Improve network socket maintenance.

	DoIP.h
	issue 5-10181 - Add socket type (UDP, TCP) to improve network socket maintenance.

	j1699.c
	Update version number.

	RequestSID.c
	issue 5-10172 - Test 12 - Some DoIP ECU responses are not being process or logged.  Set TxMsg ExtraDataIndex to Max to ensure that the transmitted DoIP message is logged.

	SaveSIDResponseData.c
	issue 5-10174 - Test 12 - Support up to 239 ECU for DoIP.




Revision 04.06.00
	CheckIDSupport.c
	issue 5-10109 - Test 12.3 Fails because no $F5xx DIDs are supported, but there is no requirement to support this range for ZEVs.
					Don't fail for no response to DID-Support DIDs which are not supported.
					
	DoIP.c
	issue 5-10125 - Software not correctly parsing data from DoIP socket that contains more than one DoIP message.
	issue 5-10126 - DoIP Req MSG not being written to log. 

	j1699.c
	Update version number.
	issue 3-1106  - Add a "\n" after prompt in Q4, Q5, Q12 User Name, LogPrint.c (ln 287, 381).
	issue 5-10102 -	VerifyVehicleState is reporting that a non-Hybrid vehicle is a Hybrid.
	                S/S vehicle should not set gbHybrid to TRUE.

	j1699.h
	issue 5-10132 - Add variables to support request of $19 $1A $92 (Test Result List).
	issue 5-10133 - Add variables to support request of $19 $06 $92 (Test Result Data).
	issue 5-10134 - Add variables to support request of SID $31 (Routine Identifiers)
	issue 5-10148 - Update variable names to match test numbers - Tests 11.7.1 - Add $19 $06 DTC $91, IUMPR by DTC.				
	issue 5-10149 - Update variable names to match test numbers - Tests 11.7.2 - Add $19 $06 DTC $93, SMAD by DTC.				
	issue 5-10151 - Update variable names to match test numbers - Tests 11.12.1 - Add $19 $06 DTC $91, IUMPR by DTC.				
	issue 5-10152 - Update variable names to match test numbers - Tests 11.12.2 - Add $19 $06 DTC $93, SMAD by DTC.				
															     
	LogMsg.c
	issue 5-10126 - DoIP Req MSG not being written to log. 

	RequestSID.c
	issue 5-10128 - DoIP "ACK message correctly received, processed, and put into transmit buffer." being counted as ECU response message in RequestSID().				
	issue 5-10126 - DoIP Req MSG not being written to log. 

	ResetSIDResponseData.c
	issue 5-10126 - DoIP Req MSG not being written to log. 
	issue 5-10132 - Add support for request of $19 $1A $92 (Test Result List).
	issue 5-10133 - Add support for request of $19 $06 $92 (Test Result Data).
	issue 5-10134 - Add support for request of SID $31 (Routine Identifiers)

	SaveSIDResponseData.c
	issue 5-10132 - Add support for request of $19 $1A $92 (Test Result List).
	issue 5-10133 - Add support for request of $19 $06 $92 (Test Result Data).
	issue 5-10134 - Add support for request of SID $31 (Routine Identifiers)

	Test10_InUseCounters.c
	issue 3-1105  - Test 10.3 - why is _cgets_s being used instead of scanf_s
	issue 5-10137 - Tests 10.3 - Add collecting of DTC Extended Data $91 (IUMPR), $92 (Test Results), and $93 (SMAD).				
	issue 5-10140 - Tests 10.7 - Add Physically Addressed $19 $06 $92 (Test Results).				
	issue 5-10141 - Tests 10.10.1 - Add $19 $56 to list DTCs for each Readiness Groups.				
	issue 5-10142 - Tests 10.10.3 - Add for each DTC obtained in 10.3, send physically addressed request for IUMPR data.				
	issue 5-10143 - Tests 10.10.4 - Add for each DTC obtained in 10.3, send physically addressed request for SMAD data.				

	Test11_PerformanceCounters.c
	issue 3-1107  - Can we make Test 11.2 key instructions into a 'Prompt'?
	issue 5-10121 - Test 11.1 is FAILs ECU for IUMPR counters that have not changed since Test 10.10, but there is no requirement to do so.
	issue 5-10145 - Tests 11.1.2 - Add $19 $06 DTC $91, IUMPR by DTC.				
	issue 5-10146 - Tests 11.1.3 - Add $19 $06 DTC $93, SMAD by DTC.				
	issue 5-10147 - Tests 11.6 - Add $19 $06 DTC $92, Test Results by DTC.				
	issue 5-10148 - Tests 11.7.1 - Add $19 $06 DTC $91, IUMPR by DTC.				
	issue 5-10149 - Tests 11.7.2 - Add $19 $06 DTC $93, SMAD by DTC.				
	issue 5-10151 - Tests 11.12.1 - Add $19 $06 DTC $91, IUMPR by DTC.				
	issue 5-10152 - Tests 11.12.2 - Add $19 $06 DTC $93, SMAD by DTC.				

	Test12_ZEV.c
	issue 5-10073 - Add ZEV Fault Insertion tests (12.8-11)

	Test5_NoDTC.c
	issue 5-10131 - Test 5.3 - Add check for SID $04 (Classic OBD II).				
	issue 5-10132 - Tests 5.5.2 & 5.13.1 - Add request for $19 $1A $92.				
	issue 5-10133 - Tests 5.5.3 & 5.13.2 - Add request for $19 $06 for all DTCs returned from $19 $1A $92.				
	issue 5-10134 - Tests 5.7 & 5.15 - Add VerifyService $31.				

	Test9_NoFaultsAfter3DriveCycles.c
	issue 5-10135 - Tests 6.2, 7.2, 8.2, 9.2, 10.8, 11.10 - Add check that Pending DTC Status reports correct values.				

	VerifyConfirmedDTCData.c
	issue 5-10136 - Tests 6.3, 7.3, 8.3, 9.3, 9.8, 10.9, 11.9 - Add check that Confirmed DTC Status reports correct values.				

	VerifyDTCExtData.c
	issue 5-10119 - Test 10.10 will decode 0's for all ECUs IUPMR and SMAD data if one of the ECUs issues an NCR. This is a 'continue on FAILURE' issue.
	issue 5-10120 - Test 10.14 - Add ECU ID to SMAD data decode.
	issue 5-10132 - Add support for $19 $1A $92 (Test Result List).				
	issue 5-10133 - Add support for $19 $06 $92 (Test Result Data).				
	issue 5-10137 - Add support for $19 $06 $92 (Test Result Data).				
	issue 5-10140 - Add support for $19 $06 $92 (Test Result Data).				

	VerifyINFSupportAndData.c
	issue 5-10116 - Test 12.7 Fails because $F80A list is not correct.

	VerifyMILData.c
	5-10099	Test 7.4 Fails if all F501 responses don't indicate that MIL is active.

	VerifyPendingDTCData.c
	issue 5-10135 - Tests 6.2, 7.2, 8.2, 9.2, 10.8, 11.10 - Add check that Pending DTC Status reports correct values.				
	
	VerifyPIDSupportAndData.c
	issue 5-10073 - Update checks for ZEV.
	issue 5-10105 - Test 10.6 is not decoding the ECU response to $F501, it appears to be decoding an older response from Test 10.2.
	issue 5-10111 - Test 12.3 Fails because $F4D1 is 00 00 00 00, but there is no requirment to evaluate the content.
	issue 5-10112 - Test 12.3 Fails because $F4D6 is 00 00, but it should be 0.
	issue 5-10113 - Test 12.3 Fails because $F4DA is 00 00 00 00, but there is no requirement to evaluate the content.
	issue 5-10115 - Test 12.3 Fails because $F4D5 is supported on a ZEV, but this DID is only required to be supported on FCEV (FUEL CELL).
	issue 5-10129 - Remove NRC requirement for a Functionally Addressed request for and unsupported SID $22 DID $F401, $F402, or $F441.
	
	VerifyReverseOrderSupport.c
	issue 5-10129 - Remove NRC requirement for a Functionally Addressed request for and unsupported SID $22 DID $F401, $F402, or $F441.

	VerifyRIDSupportAndData.c
	issue 5-10134 - Add file to support request of SID $31 (Routine Identifiers)
	
	VerifyTIDSupportAndData.c
	issue 5-10134 - delete file (replaced by VerifyRIDSupportAndData.c)
	
	VerifyVehicleState.c
	issue 5-10102 -	VerifyVehicleState is reporting that a non-Hybrid vehicle is a Hybrid.
	                Log S/S status when engine state isn't as expected.





Revision 04.04.01
	j1699.c
	Update version number.

	ConnectProtocol.c
	issue 5-10108 - Remove PassThruIoctl(READ_PIN_VOLTAGE) from DoIP ConnectProtocol.

	DoIP.c
	issue 5-10124 - Change Routing Activation Request message for Starting DoIP Channel.
	
	
	
	
Revision 04.04.00
	CheckIDSupport.c
	issue 5-10067 - Log FAILURE when an NRC $31 is received for DID-Support DID request because it is not supported.
	issue 5-10075 - Improve group requests to continue to request even if there were problems to reduce fails in single response comparison.
	issue 5-10076 - Fail if an ECU indicates support for the next DID-Support DID, but that DID-Support DID is not supported (no response).y

	ConnectProtocol.c
	issue 5-10096 - Add support for CAN on ZEV.

	InitProtocolList.c
	issue 5-10096 - Add support for CAN on ZEV.

	j1699.c
	Update version number.
	issue 5-10022 - Add support for ACC-II PHEV in ZEV Validation Tests.
	issue 3-1103  - Fix the prompt for Vehicle Type to say "3 Medium Duty Truck Engine Dyno Certified (< 14,000 lbs GVWR)", instead of "1400".
	issue 5-10074 - Add "ICE" to Prompt Q02 selections #1 and #2 and "ACC II" PHEV to #3.

	j1699.h
	issue 5-10096 - Add support for CAN on ZEV.
	issue 5-10022 - Add support for ACC-II PHEV in ZEV Validation Tests.
	issue 5-10077 - Add support for up to 1024 DTC IUMPRs, SMAD and IM Readiness list entries (number of entries in a 4k msg).
	issue 5-10094 - Add nak code variable to support requirement that unsupported DID requests should respond with NAK $31 in physical addressing (and $F401, $F402 and $F441 in functional addressing).
	izzue 5-10078 - Change "Test9_8to21_PermanentCodes" to "Test9_7to18_PermanentCodes" to match subtest renumbering caused by removing some DetermineProtocol tests.
	
	RequestSID.c
	issue 5-10094 - Add support for the requirement that unsupported DID requests should respond with NAK $31 in physical addressing (and $F401, $F402 and $F441 in functional addressing).
	issue 5-10022 - Add support for ZEV DID validation tests.
	
	ResetSIDResponseData.c
	issue 5-10063 - Do not fail a broadcast request for a Readiness Group that is not supported by the vehicle.
	issue 5-10096 - Add support for CAN on ZEV.
	
	SaveSIDResponseData.c
	issue 5-10063 - Do not fail a broadcast request for a Readiness Group that is not supported by the vehicle.
	issue 5-10077 - Add support for up to 1024 DTC IUMPRs, SMAD and IM Readiness list entries (number of entries in a 4k msg).
	issue 5-10022 - Size checks for new PIDs: $F4C1, C2, C4, C5, C6, C8, CC, CD, CE, D0, D1, D4, D2, D5, D6, D8, D9, DA, DB, DC
	issue 5-10094 - Add support for the requirement that unsupported DID requests should respond with NAK $31 in physical addressing (and $F401, $F402 and $F441 in functional addressing).
	issue 5-10096 - Add support for CAN on ZEV.
	
	Test10_InUseCounters.c
	issue 3-1104  - Fix the prompt in Test 10.12 to say "(BARO > 22 in Hg)", instead of "(BARO < 22 in Hg)".
	issue 5-10077 - Add support for up to 1024 DTC IUMPRs, SMAD and IM Readiness list entries (number of entries in a 4k msg).
	issue 5-10078 - Change gTestSubsection checks to match subtest renumbering caused by removing some DetermineProtocol tests.
	
	Test11_PerformanceCounters.c
	issue 5-10077 - Add support for up to 1024 DTC IUMPRs, SMAD and IM Readiness list entries (number of entries in a 4k msg).
	
	Test12_ZEV.c
	issue 5-10022 - Add ZEV DID Validation Tests.
	
	Test5_NoDTC.c
	issue 5-10078 - Remove DetermineProtocol test from Test 5.8.
	
	Test6_PendingDTC.calculation
	issue 5-10078 - Remove DetermineProtocol test from Test 6.2 (renumber remaining tests 6.3->6.2 ... 6.6->6.5).
	
	Test7_ConfirmedDTC.c
	issue 5-10078 - Remove DetermineProtocol test from Test 7.2 (renumber remaining tests 7.3->7.2 ... 7.5->7.4).
	
	Test8_FaultRepaired.c
	issue 5-10078 - Remove DetermineProtocol test from Test 8.2 (renumber remaining tests 8.3->8.2 ... 8.6->8.5).
	
	Test9_NoFaultsAfter3DriveCycles.c
	issue 5-10078 - Remove DetermineProtocol test from Test 9.2 (renumber remaining tests 9.3->9.2 ... 9.7->9.6, 9.22->9.18, 9.23->9.19).
	
	Test9_7to17_PermanentCodes.c    renamed from    Test9_8to21_PermanentCodes.c
	issue 5-10078 - Remove DetermineProtocol test from Test 9.9, 9.11, 9.17, 9.21 (renumber remaining tests 9.8->9.7, 9.10->9.8 ... 9.18->9.15).
	
	VerifyConfirmedDTCData.c
	issue 5-10060 - Fix failing for a Type A (first trip) DTC, in Test 6.3.
	
	VerifyDTCExtData.c
	issue 5-10063 - Do not fail a broadcast request for a Readiness Group that is not supported by the vehicle.
	issue 5-10077 - Add support for up to 1024 DTC IUMPRs, SMAD and IM Readiness list entries (number of entries in a 4k msg).
	
	VerifyINFSupportAndData.c
	issue 5-10022 - Add ZEV DID Validation and Update Tests.
					Add logging and evaluation of $F881, 85-9F, A1-B4
					Update evaluation of $F882.
	issue 5-10085 - Fix the units in the Warnings for $F841 EOE-A from sec to MWh.
	issue 5-10086 - Fix the units in the Warnings for $F845 EOE-L from sec to GWh.
	issue 5-10087 - Remove Warning/Failure for $F841 VFC-A, $F842 EFC-A, and IEFC-A == to 0 In Test 5.16.
	issue 5-10068 - Add Fail if $F878 Engine Rated Power and Engine Rated Speed are set to 0 In Test 5.16.
	issue 5-10078 - Change gTestSubsection checks to match subtest renumbering caused by removing some DetermineProtocol tests.

	VerifyMILData.c
	issue 5-10081 - Request PID-Support PIDs before physically addressed request of SID $22 DID $F501, if they have not been populated yet.
	
	VerifyPIDSupportAndData.c
	issue 3-1102  - Update PID $1C to decode up to $3B.
	issue 5-10083 - FAIL if DID $F401 is supported.
	issue 5-10094 - Fail if no NRC for a physical request of a DID that is not supported.
	issue 5-10090 - Fail if no NRC for a functional request of DID $F401, $F402, $F441, if not supported.
	issue 5-10022 - Add ZEV DID Validation and Update Tests.
	                Update $F44D evaluation for ZEV,
					Update $F49A evaluation to fail if HEV_BATT_A <= 0,
					Add evaluation of $F4B2-BF, C1, C2, C4-C6, C8, CA, CC-CE, D0-D2, D4-D6, D8-DC,
					Update support requirements to account for ZEVs for $F404, 0C, 1C, 1F, 21, 2F, 30, 31, 33, 42, 46, 49, 4A, 4B, 4D, 4E, 51, 5B, 62, 9A, A6, B1:, B2, B9, D0, D1, D5, D6, DA, F501, F502, F504.
					
	VerifyReservedServices.c
	issue 5-10080 - Test 5.4 should request deprecated SID $01 PID $01 instead of PID $00 in Test 5.4.
	
	VerifyReverseOrderSupport.c
	issue 5-10094 - Fail if no NRC for a physical request of a DID that is not supported.
	issue 5-10090 - Fail if no NRC for a functional request of DID $F401, $F402, $F441, if not supported.
	issue 5-10092 - Fix false failure when less than 3 PIDs are supported in $F5xx range, causing group/single DID size mismatch.




Revision 04.00.00
	CheckIDSupport.c
	issue 5-10059 - Fail if $F4E0 indicates support for $F500, after 2026.

	ClearCodes.c
	issue 5-10053 - Do not fail for NRC $31 when an ECU does not support a physically addressed SID $14 request.
	
	ConnectProtocol.c
	issue 5-10001 - Add support for DoIP (j2534 NDIS).

	DetermineProtocol.c
	issue 5-10001 - Add support for DoIP (j2534 NDIS).

	DoIP.c
	issue 5-10001 - File added for support of DoIP (j2534 NDIS).

	DoIP.h
	issue 5-10001 - File added for support of DoIP (j2534 NDIS).

	FindJ2534Interface.c
	issue 5-10001 - Add support for DoIP (j2534 NDIS).
	
	InitProtocolList.c
	issue 5-10001 - Add support for DoIP (j2534 NDIS).

	j1699.c
	Update version number.
	issue 5-10001 - Add support for DoIP (j2534 NDIS).
	issue 5-10069 - Update test category selection prompts to match requirements document.

	j1699.h
	issue 5-10001 - Add support for DoIP (j2534 NDIS).
	issue 5-10069 - Add items to support updated test category selection prompts.
	issue 5-10062 - Add support for up to 255 DTC IUMPRs.

	j2534.h
	issue 5-10001 - Add support for DoIP (j2534 NDIS).

	LogMsg.c
	issue 5-10001 - Add support for DoIP (j2534 NDIS).

	LogPrint.c
	issue 5-10001 - Add support for DoIP (j2534 NDIS).
	
	RequestSID.c
	issue 5-10001 - Add support for DoIP (j2534 NDIS).
	issue 5-10053 - Do not fail for NRC $31 when an ECU does not support a physically addressed SID $14 request.

	ResetSIDResponseData.c
	issue 5-10001 - Add support for DoIP (j2534 NDIS).
	issue 5-10053 - Do not fail for NRC $31 when an ECU does not support a physically addressed SID $14 request.
	
	SaveSIDResponseData.c
	issue 5-10001 - Add support for DoIP (j2534 NDIS).
	issue 5-10053 - Do not fail for NRC $31 when an ECU does not support a physically addressed SID $14 request.
	issue 5-10062 - Add support for up to 255 DTC IUMPRs.
	
	Test10_InUseCounters.c
	issue 5-10064 - Remove Fail/Warnings for $F808/F80B
	
	Test11_PerformanceCounters.c
	issue 5-10062 - Add support for up to 255 DTC IUMPRs.
	
	Test12_ZEV.c
	issue 5-10001 - File added support for DoIP (j2534 NDIS) (vehicle initialization only)
	
	VehicleReport.c
	issue 5-10070 - Fix an incorrect pointer assignment which could prevent evaluation of Protocol ID response.
	
	VerifyConfirmedDTCData.c
	issue 5-10060 - Do not fail for Type A DTC in Test 6.4.
	
	VerifyDTCExtData.c
	issue 5-10062 - Add support for up to 255 DTC IUMPRs.
	
	VerifyINFSupportAndData.c
	issue 5-10056 - Fix text of Fail/Warn messages which should say "INF $F841 EOE-A must return a value of greater than 1 sec" instead of "INF $F841 ERT-A must return a value of greater than 1 sec".
	issue 5-10057 - Fix text of Fail/Warn messages for INF $F854 AT2_TIME_S which incorrectly reports "AT1_TIME-S", AT2_DT-S  which incorrectly reports "AT1DT-S", and AT2_DT-L  which incorrectly reports "AT1DT-L".
	issue 5-10058 - Remove INF $F81D-1F, $F821-2A Fail/Warnings for data equal to zero and lifetime values equal to recent values, 
	                remove $F841,45 DT Fail/Warnings for equal to zero,
	                remove $F842,46 UERT and PKE Fail/Warnings for equal to zero,
	                add    $F842,44,46 PTOERT and PTOFC max value check for non-support indication,
					change $F842 EFC equal to zero from Warn for all to Warn for P/HEV and Fail for conventional,
	                change $F842 IERT equal to zero from Fail for all to for Fail for conventional,
	                add    $F842 IEFC equal to zero check with Warn for P/HEV and Fail for conventional,
	                change $F845 EOE equal to zero from Warn for P/HEV and Fail for conventional to Warn for all,
	                change $F846 EFC and IEFC equal to zero from Warn for all to for Warn for conventional,
	                remove $F851-5B Fail for stored and lifetime values equal to zero,
	                remove $F861-66 (Active) Fail for values not being zero after reset,
	                remove $F867-76 (Stored and Lifetime) Fail for values equal to zero.
	issue 5-10064 - Remove Fail/Warnings for $F808/F80B
	issue 3-1086  - Collect the sum of $F863,69,6F,73 [bin2] through [bin14] for comparison to [bin1] and add check that the values of $F873 (EAL) are greater than $F863 (Active) Test 5.16 values.
	issue 3-1087  - Collect the sum of $F864,6A,70,74 [bin2] through [bin14] for comparison to [bin1] and add check that the values of $F874 (EAL) are greater than $F864 (Active) Test 5.16 values.
	issue 3-1088  - Collect the sum of $F865,6B,71,75 [bin2] through [bin14] for comparison to [bin1] and add check that the values of $F871 (Lifetime) and $F875 (EAL) are greater than $F865 (Active) Test 5.16 values.
	issue 3-1089  - Collect the sum of $F866,6C,72,76 [bin2] through [bin14] for comparison to [bin1] and add check that the values of $F872 (Lifetime) and $F876 (EAL) are greater than $F865 (Active) Test 5.16 values.
	issue 3-1090  - Remove INF $F818 EOE-R, EOE-L, PKE-R, and PKE-L checks for greater than 0 or comparisons to 5.17 data in Test 9.22.
	
	VerifyPIDSupportAndData.c
	issue 5-10051 - Remove PID Support check for $F4AD,AF,B0,D3,D7
	issue 5-10059 - Fail if $F4E0 indicates support for $F500, after 2026.
	issue 5-10061 - Test 5.10 should not fail if $F502,03 misfire count is greater than 0.
	issue 5-10066 - Correct pointer assignment so that DisplayPid01 displays the data in $F401 instead of $F501.
	issue 5-10071 - Correct $F41C range check for greater than or equal to instead of just greater than MAX_OBD_TYPES




Revision 03.05.01
	CheckIDSupport.c
	issue 5-10050 - Add missing newline to end of failure message for DID-Support DID indicating no DIDs supported.

	j1699.c
	Update version number.

	VerifyINFSupportAndData.c
	issue 5-10048 - Test 5.16 - Storing/evaluating of INFs over $7F may cause the application to crash.
	issue 5-10049 - Fix incorrect subtest check which prevented INF $F810 from being checked to ensure that all ECUs respond with $01.




Revision 03.05.00
	CheckIDSupport.c
	issue 5-10017 - Changes to treat the $F4xx and $F5xx ranges as independant.

	ClearCodes.c
	issue 5-10024  - Clean up defunct, commented-out code and change Physically/Functionally addressed coding for new standard.

	j1699.c
	Update version number.
	issue 3-1077  - Change Max Model Year to 2039.
	issue 3-1078  - Fix compliance test selection (Q10) to accept more than one digit.
	issue 5-10005 - Allow selection of Dynamic Tests.

	j1699.h
	issue 5-10005 - Add definitions for DTC-based IUMPR, SMAD and IM Readiness data and change some types for more univerasal compatibility.
	issue 5-10017 - Changes to treat the $F4xx and $F5xx ranges as independant.
	issue 5-10030  - Add new define for INF $F82A (INF_TYPE_EDSMD) and INF $F882 (INF_TYPE_IPD_UDS).

	RequestSID.c
	issue 5-10005 - Add support for handling SID $19 LEV $04, $06, $1A, and $56 requests.

	SaveSIDResponseData.c
	issue 5-10005 - Add support for handling SID $19 LEV $06 and $1A, DTCEDRN $91 and $93, and LEV $56 responses.
	issue 5-10017 - Changes to treat the $F4xx and $F5xx ranges as independant.
	issue 5-10023  - Add size checks for PID $F4A7,A8,AA,AC-B1,C3,C7,C9,CB,CF,D3,D7.

	Test10_InUseCounters.c
	issue 5-10005 - Add definitions and functions to support DTC-based IUMPR, SMAD, and IM Readiness and for In-Use Performance Data from INF $F882 (instead of INF $08 or $0B).
	issue 5-10017 - Changes to treat the $F4xx and $F5xx ranges as independant.
	issue 5-10025  - Comment out MID tests.

	Test11_PerformanceCounters.c
	issue 5-10005 - Add definitions and functions to support DTC-based IUMPR, SMAD, and IM Readiness and for In-Use Performance Data from INF $F882 (instead of INF $08 or $0B) and IM Readiness Data from PID $F501 (instead of PID $01 and $41).
	issue 5-10025  - Comment out MID tests.

	Test5_NoDTC.c
	issue 5-10017 - Changes to treat the $F4xx and $F5xx ranges as independant.
	issue 5-10025  - Comment out MID tests (and VerifyVehicleState tests when the rest of the test section is not performed).

	Test9_8to21_PermanentCodes.c
	issue 5-10005 - Change VerifyIPTData to VerifyIPD to support new In-Use Performance Data function.

	VehicleReport.c
	issue 5-10017 - Changes to treat the $F4xx and $F5xx ranges as independant.

	VerifyConfirmedDTCData.c
	issue 5-10005 - Changes for new DTC type definitions.

	VerifyDTCExtData.c
	issue 5-10005 - New file to contain definitions and functions to support DTC-based IUMPR, SMAD, and IM Readiness.

	VerifyFFSupportAndData.c
	issue 5-10005 - Changes for new DTC type definitions.

	VerifyINFSupportAndData.c
	issue 3-1066  - Fix incorrect expected number of ECU displayed in failure message for INF $6 CVN support.
	issue 3-1067  - Remove greater than zero check of IEFC-A in evaluation of INF $42.
	issue 3-1069  - Change INF $F878 verification to only fail RPM_RATING for zero (no other range checks).
	issue 3-1070  - INFs $F848-50 support required for PHEV only.
	issue 3-1071  - INF $F851 support required for S/S only.
	issue 3-1072  - INFs $F852-5B only warn for non-support.
	issue 3-1075  - INF $F847 support required for PHEV only.
	issue 3-1077  - Add support for up to Model Year 2039.
	issue 3-1079  - INFs $F816-29 parameters which report max value or "not available" are not evaluated in any test step.
	issue 3-1080  - Remove max INF ID check.
	issue 5-10005 - Change INF $F882 verification function to use functions in common with dynamic testing.
	issue 5-10026 - Fix the misspelling in RequestGrouPIDSupportData to RequestGroupPIDSupportData (found while working on 5-10017)
	issue 5-10030 - Added function to evaluate INF $F82A.
	issue 5-10031 - Added required support evaluate for INF $F883 and $F884.
	issue 5-10033 - Change INF $F817 evaluation to warn if Recent and Lifetime DT values are zero OR equal, warn if Recent and Lifetime FC values are zero for HEV or PHEV, fail if Recent and Lifetime FC values are equal for CONV and S/S, and fail if Fuel Consumed Bytes not supported for EOBD.
	issue 5-10034 - Change INF $F818 evaluation to fail if Recent and Lifetime values are equal or zero for CONV and S/S or warn for HEV and PHEV.
	issue 5-10035 - Change INF $F819 evaluation to fail if Recent and Lifetime values are equal or zero for Total and Idle PSA and warn if Recent and Lifetime values are zero or Equal for City PSA.
	issue 5-10036 - Change INF $F81A-1C evaluation to warn if Recent and Lifetime values are equal or zero for PHEV.
	issue 5-10037 - Change INF $F81D-1F,21-2A evaluation to warn if Recent and Lifetime values are equal or zero and warn if it is supported but all timers are "not available".
	issue 5-10038 - Change INF $F841 verification to fail if ERT and EOE Active counters are zero for CONV and S/S or warn if P/HEV, and warn if DT and FC Active counter are zero.
	issue 5-10039 - Change INF $F842 verification to fail if Idle Active counters (except Idle FC, see 3-1067) are zero and warn if Engine FC, Idle FC, Urban Speed Run, and PKE counters are zero.
	issue 5-10040 - Change INF $F845 verification to fail if ERT and EOE lifetime counters are zero for CONV and S/S or warn if P/HEV, and warn if DT and FC lifetime counter are zero.
	issue 5-10041 - Change INF $F846 verification to fail if Idle run time lifetime counter are zero and warn if Engine FC and Idle FC, PKE, and Urban Speed Run counters are zero.
	issue 5-10042 - Change INF $F847 verification to fail if Total and Idle PSA time Lifetime counters are zero for P/HEV and warn if Urban PSA Active and Lifetime counters are zero for P/HEV.
	issue 5-10043 - Change INF $F848-50 verification to fail if Stored and Lifetime counters are zero for PHEV and warn if Active and Lifetime counters are both zero for PHEV.
	issue 5-10044 - Change INF $F851-5B verification to fail if Stored and Lifetime counters are zero.
	issue 5-10045 - Change INF $F861-66 verification to fail if Active data is not zero after clear codes command.
	issue 5-10046 - Change INF $F867-6C verification to fail if Stored data is zero.
	issue 5-10047 - Change INF $F86D-76 verification to fail if Lifetime data is zero.

	VerifyMIDSupportAndData.c
	issue 5-10026 - Fix the misspelling in RequestGrouPIDSupportData to RequestGroupPIDSupportData (found while working on 5-10017)

	VerifyMILData.c
	issue 5-10017 - Changes to treat the $F4xx and $F5xx ranges as independant.

	VerifyPendingDTCData.c
	issue 5-10005 - Changes for new DTC type definitions.

	VerifyPermanentDTCData.c
	issue 5-10005 - Changes for new DTC type definitions.

	VerifyPIDSupportAndData.c
	issue 3-1076  - Remove reserved bit checks from SID $1 PIDs $A3-5, $A9, $AB-E, $B0 evaluations.
	issue 5-10017 - Changes to treat the $F4xx and $F5xx ranges as independant.
	issue 5-10019 - Don't fail for non-support of PIDs $F503 or $F505.
	issue 5-10026 - Fix the misspelling in RequestGrouPIDSupportData to RequestGroupPIDSupportData (found while working on 5-10017)
	issue 5-10029 - Fix formatting of printing of values in PID $F4C9 and $F4CB.
	issue 5-10028 - Fix PID display for $F505 (it used to mistakely show $F504).
	issue 5-10027 - Fix MDDC check for PID $F4A2 (was incorrectly compared to gstUserInput.eComplianceType, now compared to gstUserInput.eVehicleType).
	issue 5-10032 - Add evaluation for PIDs $F4CF,D3,D7
	
	VerifyReverseOrderSupport.c
	issue 5-10017 - Changes to treat the $F4xx and $F5xx ranges as independant (and make functions more generic).

	VerifyTIDSupportAndData.c
	issue 5-10026  - Fix the misspelling in RequestGrouPIDSupportData to RequestGroupPIDSupportData (found while working on 5-10017)





Revision 02.06.01
	ClearCodes.c
	issue 5-10015 - Change Europe and China compliance types to better match document.

	DetermineProtocol.c
	issue 5-10008 - Fix loss of 29-bit communication after second determination of protocol.

	j1699.c
	Update version number.
	issue 5-10015 - Change Europe and China compliance types to better match document.
	issue 5-10016 - Replace EngineType with EnergyType and FuelType to match document.

	j1699.h
	issue 5-10016 - Add definitions for EnergyType and FuelType and remove EngineType and gbDiesel.
	issue 5-10015 - Change Europe and China compliance types to better match document.

	LogPrint.c
	issue 5-10016 - Replace logging of EngineType with logging of EnergyType and FuelType to match document.

	RequestSID.c
	issue 5-10012 - Fix error in handling response to SID $19 $04 $33 $04 (and $08).

	ResetSIDResponseData.c
	issue 5-10012 - Fix error in handling response to SID $19 $04 $33 $04 (and $08).

	SaveSIDResponseData.c
	issue 5-10012 - Fix error in handling response to SID $19 $04 $33 $04 (and $08).

	Test10_InUseCounters.c
	issue 5-10016 - Replace gbDiesel check with FuelType check.

	Test11_PerformanceCounters.c
	issue 5-10015 - Change Europe and China compliance types to better match document.
	issue 5-10016 - Replace gbDiesel check with FuelType check (replace spark and compression ignition with Gasoline and Diesel in comments) to match document.

	Test5_NoDTC.c
	issue 5-10011 - Remove Freeze Frame Data test.

	Test6_PendingDTC.c
	issue 5-10011 - Remove Freeze Frame Data test.
	issue 5-10015 - Change Europe and China compliance types to better match document.

	Test7_ConfirmedDTC.c
	issue 5-10011 - Remove Freeze Frame Data test.

	Test8_FaultRepaired.c
	issue 5-10011 - Remove Freeze Frame Data test.

	Test9_NoFaultsAfter3DriveCycles.c
	issue 5-10011 - Remove Freeze Frame Data test.

	Test9_8to21_PermanentCodes.c
	issue 5-10015 - Change Europe and China compliance types to better match document.

	VerifyConfirmedDTCData.c
	issue 5-10012 - Fix error in handling response to SID $19 $04 $33 $04 (and $08).

	VerifyINFSupportAndData.c
	issue 5-10016 - Replace gbDiesel check with FuelType check (replace spark and compression ignition with Gasoline and Diesel in comments) to match document.
	issue 5-10015 - Change Europe and China compliance types to better match document.
	issue 3-1062  - Fix support checks for INF $F878
	issue 3-1063  - Fix support checks for INF $F877
	issue 5-10009 - Fix incorrect text in support failure for $F4AD, $F4AF, $F4B0
	issue 3-1065  - Fix loss of accuracy in calculations with large values for INFs $17,$18,$1A-C,$41-6,$48-9,$53-8,$61-4,$66-A,$6C-70,$72-4,$76-7

	VerifyMIDSupportAndData.c
	issue 5-10015 - Replace gbDiesel check with FuelType check and replace bSparkIgnMonSup with bGasolineMonSup (replace spark and compression ignition with Gasoline and Diesel in comments) to match document.

	VerifyMILData.c
	issue 5-10010 - Fix evaluation of IM Readiness bits in $F501

	VerifyPendingDTCData.c
	issue 5-10012 - Fix error in handling response to SID $19 $04 $33 $04 (and $08).

	VerifyPIDSupportAndData.c
	issue 5-10016 - Replace gbDiesel check with FuelType check (replace spark and compression ignition with Gasoline and Diesel in comments) to match document.
	issue 5-10015 - Change Europe and China compliance types to better match document.
	issue 5-10014 - Test 5.6 is failing all ECUs if they do not support EGS, CV, EGR, CSER.
	issue 5-10010 - Fix evaluation of IM Readiness bits in $F501 causing false failures.




Revision 02.06.00
	CheckIDSupport.c
	issue 5-10007 - Allow subtest to continue after failure in DID-Support DID check.

	ClearCodes.c
	issue 3-1054 - EOBD allows ECUs to reply both positively and negatively to Clear Codes request.

	ConnectProtocol.c
	issue 3-1049 - Fix additional failures when closing channels for unsupported protocols of partially-compliant j2534 interfaces.

	DetermineProtocol.c
	issue 3-1049 - Fix additional failures when closing channels for unsupported protocols of partially-compliant j2534 interfaces.

	j1699.c
	Update version number.
	issue 3-1035 - Add Medium Duty Truck to Vehicle Type Options (MD for trucks chassis certified and MDDC for trucks dyno certified).
	issue 3-1047 - Change wording to ECU number prompt to match changes in doc V17.04.
	issue 3-1053 - Add delay after banner display to prevent screen issues on Windows 11 machines.
	issue 5-10006 - Remove prompt to "Disable Tester Present Messages?" (Tester Present Messages are always disabled now).

	j1699.h
	issue 5-10002/5-10003 - Add defines for new NAK values to be supported in UDS.
	issue 3-1035 - Add Medium Duty Truck to Vehicle Type Options (MD for trucks chassis certified and MDDC for trucks dyno certified).

	LogPrint.c
	issue 3-1060 - Fix poorly formatted failure message which would cause application to crash if current and previous test vehicle types did not match.

	RequestSID.c
	issue 5-10002/5-10003 - Add support for new NAK values to be supported in UDS.

	Test10_InUseCounters.c
	issue 3-1035 - Change refernce to MD to MDDC to match new vehicle type definitions.
	issue 3-1052 - To prevent incorrect IUMPR values in Test 11.2, only free ECUs IPT memory if in Test 9.19, move ReadIPT to TestToVerifyPerformanceCounters.c (the only file where it's called).

	Test11_PerformanceCounters.c
	issue 3-1057 - Fix improper failure on ESC (Abort) from test 11.2, also note any true failures before allowing test to abort.
	issue 3-1051 - Log UNSUPPORTED for unsupported IUMPR rather than zero to match on screen display.

	Test6_PendingDTC.c
	issue 3-1047 - Change wording to Test 6.1 prompt to induce failure and drive cycle prompt to match changes in doc V17.04.

	Test7_ConfirmedDTC.c
	issue 3-1047 - Change wording to Test 7.1 prompt to keep failure present prompt to match changes in doc V17.04.

	Test9_8to21_PermanentCodes.c
	issue 3-1047 - Change wording to Test 9.8 prompt to induce failure and drive cycle prompt to match changes in doc V17.04.

	VerifyINFSupportAndData.c
	issue 3-1035 - Change old refernces to MD to MDDC and add new MD to match new vehicle type definitions.
	issue 3-1048 - INF $77 should not have a phase-in period warning.

	VerifyMIDSupportAndData.c
	issue 5-10002/5-10003 - Add support for new NAK values to be supported in UDS

	VerifyMILData.c
	issue 5-10002/5-10003 - Add support for new NAK values to be supported in UDS.

	VerifyPendingDTCData.c
	issue 5-10004 - Allow use of ignored DTCs read from ini file.

	VerifyPIDSupportAndData.c
	issue 5-10002/5-10003 - Add support for new NAK values to be supported in UDS.
	issue 3-1060 - Add evaluation for $F4A2.
	issue 3-1035 - Change old refernces to MD to MDDC and add new MD to match new vehicle type definitions.



Revision 02.03.00

Files renamed to better fit naming conventions:
CheckMILLight.c                           changed to  CheckMIL.c
DIDSupport.c                              changed to  CheckIDSupport.c
SidRequest.c                              changed to  RequestSID.c
SidResetResponseData.c                    changed to  ResetSIDResponseData.c
SidSaveResponseData.c                     changed to  SaveSIDResponseData.c
TestToVerifyInUseCounters.c               changed to  Test10_InUseCounters.c
TestToVerifyPerformanceCounters.c         changed to  Test11_PerformanceCounters.c
TestToVerifyPermanentCodes.c              changed to  Test9_8to21_PermanentCodes.c
TestWithConfirmedDtc.c                    changed to  Test7_ConfirmedDTC.c
TestWithFaultRepaired.c                   changed to  Test8_FaultRepaired.c
TestWithNoDtc.c                           changed to  Test5_NoDTC.c
TestWithNoFaultAfter3DriveCycles.c        changed to  Test9_NoFaultsAfter3DriveCycles.c
TestWithPendingDtc.c                      changed to  Test6_PendingDTC.c
VerifyControlSupportAndData.c             changed to  VerifyTIDSupportAndData.c
VerifyDiagnosticBurstSupport.c            changed to  VerifyPIDBurstSupport.c
VerifyDiagnosticSupportAndData.c          changed to  VerifyPIDSupportAndData.c
VerifyDTCPendingData.c                    changed to  VerifyPendingDTCData.c
VerifyDTCStoredData.c                     changed to  VerifyConfirmedDTCData.c
VerifyFreezeFrameSupportAndData.c         changed to  VerifyFFSupportAndData.c
VerifyLinkActive.c                        changed to  VerifyECUCommunication.c
VerifyMonitorTestSupportAndResults.c      changed to  VerifyMIDSupportAndResults.c
VerifyPermanentCodeSupport.c              changed to  VerifyPermanentDTCData.c
VerifyVehicleInformationSupportAndData.c  changed to  VerifyINFSupportAndData.c


Files removed from j1699-5 project to consolidation related functionality to fewer files:
IsDTCPending.c functionality moved to  VerifyPendingDTCData.c
IsDTCStored.c  functionality moved to  VerifyConfirmedDTCData.c

all .c and .h files
	Update code for move to Visual Studio 2022, safer string and dynamic memory handling, standardization of variable naming and coding practices,
	commonization of code with j1699-3, and implementing V2.3 of the j1699-5 document.

	ClearCodes.c
	issue 3-1020 - China6 allows ECUs to reply both positively and negatively to Clear Codes request
	issue 3-1032 - China6 allows ECUs to reply both positively and negatively to Clear Codes request when engine running.

	DetermineProtocol.c
	issue 5-10000 - Use SID $22 INF $F810 for protocol identification instead of SID $1 PID $00

	j1699.c
	Update version number.
	issue 3-1033 - Change wording for Prompt Q03 to clarify VIN model year.
	issue 3-1025 - Fix sections of information missing from logfile.

	j1699.h
	issue 3-1030 - Add per ECU variable for FEOCNTR.

	LogPrint.c
	issue 3-1028 - Remove extra space between "****" and other text.

	ReadIni.c
	issue 3-1028 - Remove extra space between "****" and other text.

	SaveSIDResponseData.c
	issue 5-10000 - INF $F810 response indicates ECU's link is active

	StopTest.c
	issue 3-1025 - Fix sections of information missing from logfile.

	Test10_InUseCounters.c
	issue 1030 - Fix problems with use of pFEOCNTR causing application to crash.

	Test11_PerformanceCounters.c
	issue 3-1041 - Change TEST 11.2 on-screen text from RESERVED to GPF for gasoline vehicles.
	issue 3-1029 - Fix display of IUMPR data.
	issue 3-1031 - Fix waiting for unsupported bank completion.

	VehicleReport.c
	issue 3-1028 - Remove extra space between "****" and other text.

	VerifyECUCommunication.c
	issue 5-10000 - Use SID $22 INF $F810 for protocol identification

	VerifyPIDSupportAndData.c
	issue 3-1039 - Fix on-screen display of PID $A1 Byte A bits and comparison of NOXC11 and NOXC12 using TempData_float instead of TempData_long.
	issue 3-1040 - Fix resolution loss in calculation of PID $85 and $96 from using TempData_long instead of TempData_float (display only, no evaluation of these PIDS).

	VerifyReverseOrderSupport.c
	issue 3-1024 - Fix false failure for "Unsupported PID" in reverse order check of PID Support PIDs.

	VerifyINFSupportAndData.c
	issue 3-1013 - Implement Appendix A Vehicle Configuration requirements:
	               INFs $41-$47 and $50-$5B required by US gas and diesel heavy duty vehicles,
	               INFs $61-77 required by US diesel heavy and medium duty vehicles,
	               US vehicles which do not match these vehicle configurations but support these INFs fail,
	               INF $78 is required by all US light duty and gas and diesel heavy and medium duty vehicles.
	issue 3-1034 - Improve wording of 2022-2024 phase-in warning
	issue 3-1027 - INF $78 is required by only US medium duty and heavy duty diesel vehicles.




-- Version 01 J1699-5



Revision 01.04.00

All files changed to implement UDS on ISO15765

